@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:do_flash_all
REM setup variable failure_count
set /A failure_count=0
set /A _failure_count=0

    if "%FLAG_DEVICE_IS_QCOM%" == "1" (
        call :view_flash_bl_title

        call "%~dp0do_flash_bl_qcom.cmd"
        if !errorlevel! == 1 (
            set /A _failure_count+=1
            set failure_count=!_failure_count!
            set _failure_count=
            exit /b 1
        )

        if "!flashall_skip_reboot_bl!" == "0" (
            call :do_reboot_bootloader !serial_number!
            if !errorlevel! == 1 (
                set /A _failure_count+=1
                set failure_count=!_failure_count!
                set _failure_count=
                exit /b 1
            )
        )

        call :view_flash_bp_title
        call "%~dp0do_flash_bp_qcom.cmd"
        if !errorlevel! == 1 (
            set /A _failure_count+=!failure_count!
            set failure_count=!_failure_count!
            set _failure_count=
            exit /b 1
        )
        set /A _failure_count+=!failure_count!

        call :view_flash_ap_title
        call "%~dp0do_flash_ap_qcom.cmd"
        if !errorlevel! == 1 (
            set /A _failure_count+=!failure_count!
            set failure_count=!_failure_count!
            set _failure_count=
            exit /b 1
        )
        set /A _failure_count+=!failure_count!
        goto :end_flash_device_spec

    )

    if "%FLAG_DEVICE_IS_MTK%" == "1" (
        call "%~dp0do_flash_bl_mtk.cmd"
        if !errorlevel! == 1 (
            set /A _failure_count+=1
            set failure_count=!_failure_count!
            set _failure_count=
            exit /b 1
        )

        if "!flashall_skip_reboot_bl!" == "0" (
            call :do_reboot_bootloader !serial_number!
            if !errorlevel! == 1 (
                set /A _failure_count+=1
                set failure_count=!_failure_count!
                set _failure_count=
                exit /b 1
            )
        )

        call :view_flash_bp_title
        call "%~dp0do_flash_bp_mtk.cmd"
        if !errorlevel! == 1 (
            set /A _failure_count+=!failure_count!
            set failure_count=!_failure_count!
            set _failure_count=
            exit /b 1
        )

        call :view_flash_ap_title
        call "%~dp0do_flash_ap_mtk.cmd"
        if !errorlevel! == 1 (
            set /A _failure_count+=!failure_count!
            set failure_count=!_failure_count!
            set _failure_count=
            exit /b 1
        )
        set /A _failure_count+=!failure_count!
        goto :end_flash_device_spec
    )

    if "%FLAG_DEVICE_IS_SLSI%" == "1" (
        call "%~dp0do_flash_bl_slsi.cmd"
        if !errorlevel! == 1 (
            set /A _failure_count+=1
            set failure_count=!_failure_count!
            set _failure_count=
            exit /b 1
        )

        if "!flashall_skip_reboot_bl!" == "0" (
            call :do_reboot_bootloader !serial_number!
            if !errorlevel! == 1 (
                set /A _failure_count+=1
                set failure_count=!_failure_count!
                set _failure_count=
                exit /b 1
            )
        )

        call :view_flash_bp_title
        call "%~dp0do_flash_bp_slsi.cmd"
        if !errorlevel! == 1 (
            set /A _failure_count+=!failure_count!
            set failure_count=!_failure_count!
            set _failure_count=
            exit /b 1
        )

        call :view_flash_ap_title
        call "%~dp0do_flash_ap_slsi.cmd"
        if !errorlevel! == 1 (
            set /A _failure_count+=!failure_count!
            set failure_count=!_failure_count!
            set _failure_count=
            exit /b 1
        )
        set /A _failure_count+=!failure_count!
        goto :end_flash_device_spec
    )

    :end_flash_device_spec

    call "%~dp0do_flash_ap_generic.cmd"
    set /A _failure_count+=!failure_count!

    if "%finished_factory_reset%" == "1" (
        set FLAG_KEEP_DATA=0
    )

    if "%FLAG_KEEP_DATA%" == "0" (
        call :view_factory_reset_title
        call "%~dp0do_erase_data.cmd"
        set /A _failure_count+=!failure_count!

        if "!FLAG_DEVICE_IS_QCOM!" == "1" (
            call :view_erase_modem_cache_title
            call "%~dp0do_erase_modem_cache.cmd"
            set /A _failure_count+=!failure_count!
        )
        if "!FLAG_DEVICE_IS_MTK!" == "1" (
            call :view_erase_modem_cache_title
            call "%~dp0do_erase_modem_cache.cmd"
            set /A _failure_count+=!failure_count!
        )
    )

    set failure_count=%_failure_count%
    set _failure_count=
exit /b 0
::
:do_reboot_bootloader
    if "%1" == "" (
        color fc
        echo.
        echo do_reboot_bootloader: Param serial_number missing.
        exit /b 1
    )

    call :view_reboot_opt_title BOOTLOADER
    %fastboot% -s %1 reboot-bootloader
    ping -n 3 127.1 > nul 2>nul

    call "%~dp0do_wait_fb_device.cmd" %1
    if %errorlevel% == 1 (
        exit /b 1
    )
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_flash_bl_title
    echo.
    echo ======== ˢ BL֣ ========
exit /b 0
::
:view_flash_ap_title
    echo.
    echo ======== ˢ APϵͳ֣ ========
exit /b 0
::
:view_flash_bp_title
    echo.
    echo ======== ˢ BP֣ ========
exit /b 0
::
:view_factory_reset_title
    echo.
    echo ======== ڻָ ========
exit /b 0
::
:view_erase_modem_cache_title
    echo.
    echo ======== ջ ========
exit /b 0
::
:view_reboot_opt_title
    echo.
    echo ------  %1 ------
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
