@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:do_flash_ap_qcom
REM setup variable failure_count
set /A failure_count=0

    if "%FLAG_DEVICE_HAS_VBMETA%" == "1" (
        set img_file=vbmeta.img
        set img_name=VBMETA
        set pt_name=vbmeta!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_VBMETA_SYSTEM%" == "1" (
        set img_file=vbmeta_system.img
        set img_name=VBMETA
        set pt_name=vbmeta_system!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_BLUETOOTH%" == "1" (
        set img_file=BTFM.bin
        set img_name=BLUETOOTH
        set pt_name=bluetooth!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_DSP%" NEQ "1" (
        goto :skip_flash_dsp
    )

    set img_file=
    set img_name=DSP
    set pt_name=dsp%SLOT_SUFFIX%
    REM This is a discriminant for dsp image.
    set /A A=0
    if exist adspso.bin (
        set /A A+=1
        set img_file=adspso.bin
    )
    if exist dspso.bin (
        set /A A+=1
        set img_file=dspso.bin
    )
    if %A% GTR 1 (
        set /A failure_count+=1
        call :view_flash_image_duplicate_error "adspso.bin dspso.bin"
        exit /b 1
    )
    if %A% == 1 (
        call :view_flash_image_title !img_name!
        !fastboot! -s !serial_number! flash !pt_name! !img_file!
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_flash_image_failed !img_name!
        )
    ) else (
        if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
            call :view_flash_image_not_exist_w !img_name!
        )
    )
    :skip_flash_dsp

    if "%FLAG_DEVICE_HAS_LOGO%" NEQ "1" (
        goto :skip_flash_logo
    )

    set img_file=
    set img_name=LOGO
    set pt_name=logo%SLOT_SUFFIX%
    REM This is a discriminant for logo image.
    set /A A=0
    if exist logo.bin (
        set /A A+=1
        set img_file=logo.bin
    )
    if exist logo.img (
        set /A A+=1
        set img_file=logo.img
    )
    if %A% GTR 1 (
        set /A failure_count+=1
        call :view_flash_image_duplicate_error "logo.bin logo.img"
        exit /b 1
    )
    if %A% == 1 (
        call :view_flash_image_title !img_name!
        !fastboot! -s !serial_number! flash !pt_name! !img_file!
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_flash_image_failed !img_name!
        )
    ) else (
        REM if %A% == 0
        if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
            call :view_flash_image_not_exist_w !img_name!
        )
    )
    :skip_flash_logo

    if "%FLAG_DEVICE_HAS_BOOT%" == "1" (
        set img_file=boot.img
        set img_name=BOOT
        set pt_name=boot!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_INIT_BOOT%" == "1" (
        set img_file=init_boot.img
        set img_name=INIT_BOOT
        set pt_name=init_boot!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_VENDOR_BOOT%" == "1" (
        set img_file=vendor_boot.img
        set img_name=VENDOR_BOOT
        set pt_name=vendor_boot!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_DTB%" == "1" (
        set img_file=dtb.img
        set img_name=DTB
        set pt_name=dtb!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_DTBO%" == "1" (
        set img_file=dtbo.img
        set img_name=DTBO
        set pt_name=dtbo!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_RECOVERY%" == "1" (
        set img_file=recovery.img
        set img_name=RECOVERY
        set pt_name=recovery!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_PVMFW%" == "1" (
        set img_file=pvmfw.img
        set img_name=PVMFW
        set pt_name=pvmfw!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist !img_name!
            )
        )
    )

exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_flash_image_title
    echo.
    echo ------ ˢ %1  ------
exit /b 0
::
:view_flash_image_failed
    color f6
    echo ------------------------------
    echo [] fastboot ˢ %1 ʧܣ
    echo ------------------------------
exit /b 0
::
:view_flash_image_duplicate_error
    color fc
    echo.
    echo [ش] %1 ͬʱڡȻǲԵģ飡
exit /b 0
::
:view_flash_image_not_exist
    echo.
    echo [ʾ] %1 񲻴ڡˢ...
exit /b 0
::
:view_flash_image_not_exist_w
    echo.
    echo [] %1 񲻴ڣ豸и÷ˢ...
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
