@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:menu_toolbox
call :view_menu_toolbox_t
@title %title_name%
color f9
    call :view_menu_toolbox
    call :view_press_key_num
    set selection=
    set /p selection=
    if "%selection%"=="1" cls && call :sub_run_xml2bat
    if "%selection%"=="2" cls && call :sub_run_custom_step
    if "%selection%"=="3" cls && call :sub_run_clean_factory_params
    if "%selection%"=="0" cls && exit /b 0
    cls
goto :menu_toolbox
::
::
:sub_run_xml2bat
call :view_sub_run_xml2bat_t
@title %title_name%
    call :view_xml2bat_tips
    call :view_press_key_continue

    call :input_flash_file
    if %errorlevel% == 1 (
        exit /b 1
    )

    call :input_need_factoryreset

    call "%~dp0do_xml2bat.cmd"

    color f2
    call :view_action_finished
    ping 127.0.1 -n 2 >nul 2>nul
exit /b 0
::
:input_flash_file
    set FLASH_FILE=
    call :view_input_flash_file
    set /p xmlfilename=
    if "%xmlfilename%"=="" (
        set xmlfilename=flashfile.xml
    )

    if not exist "%xmlfilename%" (
        call :view_flashfile_not_exist
        ping 127.0.1 -n 2 >nul 2>nul
        exit /b 1
    )
    set FLASH_FILE=%xmlfilename%
    set xmlfilename=
exit /b 0
::
::
:input_need_factoryreset
    set opt=
    call :view_need_factoryreset
    set /p opt=
    if /i "%opt%" == "y" cls && set "FLAG_KEEP_DATA=0" && exit /b 0
    if /i "%opt%" == "n" cls && set "FLAG_KEEP_DATA=1" && exit /b 0
goto :input_need_factoryreset
::
::
:sub_run_custom_step
call :view_sub_run_custom_step_t
@title %title_name%
    call :view_run_custom_steps_tips
    call :view_press_key_continue

    if exist "%TFS_ROOT%\tools\custom\customstep.cmd" (
        call :view_run_custom_step_title
        call "%TFS_ROOT%\tools\custom\customstep.cmd"
    ) else (
        call :view_customstep_not_found
        ping 127.0.1 -n 3 >nul 2>nul
        exit /b 0
    )

    color f2
    call :view_action_finished
    call :view_return_toolbox_menu
exit /b 0
::
::
:sub_run_clean_factory_params
call :view_sub_run_clean_factory_params_t
@title %title_name%
    call :view_clean_factory_params_tips
    call :view_press_key_continue

    call "%~dp0enumerate_fb_devices.cmd"

    if "%DEVICE_LIST%" NEQ "" (
        for %%d in (%DEVICE_LIST::= %) do (
            call :view_processing_device %%d
            set serial_number=%%d
            if "!DEVICE_COUNT!" == "1" (
                call "%~dp0run_clean_factory_params_single.cmd"
            ) else (
                start cmd /k call "%~dp0run_clean_factory_params_single.cmd"
            )
        )
    ) else (
        call :view_device_list_empty
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    call :view_return_toolbox_menu
    pause > nul
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_menu_toolbox_t
    set title_name=%title% %version% - 
exit /b 0
::
:view_menu_toolbox
    echo --------------------------------------------------------------------------------
    echo. [1] Flashfile XML ת BAT 
    echo. [2] ִԶ
    echo. [3] ִ
    echo.
    echo. [0] ^<^<^< ˵
    echo --------------------------------------------------------------------------------
exit /b 0
::
:view_run_custom_steps_tips
    echo --------------------------------------------------------------------------------
    echo. [*]  custom ļõ customstep.cmd 衣
    echo.
    echo --------------------------------------------------------------------------------
    echo.
exit /b 0
::
:view_xml2bat_tips
    echo --------------------------------------------------------------------------------
    echo. [*] ߻Ὣ flashfile.xml תΪ˫ִе .bat ļ
    echo. [*] עɺڵǰ̼ҪԽڲͬĹ̼
    echo. [*] ɺļΪ xml2batflash.batʹ˫ִмɡ
    echo.
    echo --------------------------------------------------------------------------------
    echo.
exit /b 0
::
:view_clean_factory_params_tips
    echo --------------------------------------------------------------------------------
    echo. [*] 
    echo 磺ramdumpcmdloff-charge-mode 
    echo.
    echo --------------------------------------------------------------------------------
    echo.
exit /b 0
::
:view_press_key_num
    echo|set /p="ҪִеѡŲس>>"
exit /b 0
::
:view_sub_run_xml2bat_t
    set title_name=%title% %version% - Flashfile XML ת BAT 
exit /b 0
::
:view_sub_run_custom_step_t
    set title_name=%title% %version% - ִԶ
exit /b 0
::
:view_sub_run_clean_factory_params_t
    set title_name=%title% %version% - 
exit /b 0
::
:view_input_flash_file
    echo|set /p="ļƲسĬϣflashfile.xml>>"
exit /b 0
::
:view_flashfile_not_exist
    color fc
    echo.
    echo "%1" ڣ飡
exit /b 0
::
:view_need_factoryreset
    echo|set /p="Ҫָ(Y/N) >>"
exit /b 0
::
:view_action_finished
    echo.
    echo ɡ
exit /b 0
::
:view_press_key_continue
    echo 밴Ͻ  ˳
    pause > nul
exit /b 0
::
:view_run_custom_step_title
    echo.
    echo ======== ִԶ ========
exit /b 0
::
:view_customstep_not_found
    color fc
    echo.
    echo Ҳ customstep.cmd顣
exit /b 0
::
:view_return_toolbox_menu
    echo.
    echo ع˵
    pause >nul
exit /b 0
::
:view_processing_device
    echo.
    echo ڴ豸[%1]
exit /b 0
::
:view_device_list_empty
    color fc
    echo.
    echo [ش] Ҳ豸б
exit /b 0
::
:view_press_any_key_return_main_menu
    echo.
    echo 밴˵
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
:exit
exit
