@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

@SETLOCAL enabledelayedexpansion

:run_adb_action_single
color f9
call :view_run_adb_action_single_t
@title %title_name%

    if "%1" == "" (
        call :view_action_opt_empty
        goto :tips
    )
    set /A failure_count=0

    if "%1" == "remove-frp" (
        call :do_remove_frp
        if !errorlevel! == 1 (
            set /A failure_count+=1
        )
        goto :do_adb_action_end
    )
    if "%1" == "remove-exclamation" (
        call :do_remove_exclamation
        if !errorlevel! == 1 (
            set /A failure_count+=1
        )
        goto :do_adb_action_end
    )
    if "%1" == "set-china-ntp" (
        call :do_setup_china_ntp_server
        if !errorlevel! == 1 (
            set /A failure_count+=1
        )
        goto :do_adb_action_end
    )
    :do_adb_action_end

    if %failure_count% == 0 ( color f2 )

    call :view_action_done_footer %serial_number% %failure_count%

    if "%DEVICE_COUNT%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:do_remove_frp
call :view_do_remove_frp_t
@title %title_name%
    %adb% -s %serial_number% shell content insert --uri content://settings/secure --bind name:s:user_setup_complete --bind value:s:1
    if %errorlevel% == 1 (
        call :view_action_failed !serial_number!
        exit /b 1
    )

    call :view_frp_removed_tips
    call :view_frp_remove_rebooting
    %adb% -s %serial_number% reboot
exit /b 0
::
::
:do_remove_exclamation
call :view_do_remove_exclamation_t
@title %title_name%
    REM get SDK version
    set _sdk_version=
    for /F "usebackq tokens=*" %%X in (`%%adb%% -s "%%serial_number%%" shell getprop ro.build.version.sdk 2^>^&1`) do (
        set _sdk_version=%%X
    )

    if %_sdk_version% LEQ 24 (
        !adb! -s !serial_number! shell "settings put global captive_portal_server g.cn"
        if !errorlevel! == 1 (
            call :view_action_failed !serial_number!
            exit /b 1
        )
        call :view_remove_exclamation_sucess
        exit /b 0
    )

    REM if SDK greater or equal to 25
    %adb% -s %serial_number% shell "settings put global captive_portal_http_url http://connectivitycheck.platform.hicloud.com/generate_204"
    %adb% -s %serial_number% shell "settings put global captive_portal_https_url https://connectivitycheck.platform.hicloud.com/generate_204"
    if %errorlevel% == 1 (
        call :view_action_failed !serial_number!
        exit /b 1
    )
    call :view_remove_exclamation_sucess

exit /b 0
::
::
:do_setup_china_ntp_server
call :view_do_setup_china_ntp_server_t
@title %title_name%
    %adb% -s %serial_number% shell "settings put global ntp_server ntp1.aliyun.com"
    if %serial_number% == 1 (
        call :view_action_failed !serial_number!
        exit /b 1
    )

    REM get ntp_server
    set ntp_server=
    for /F "usebackq tokens=*" %%X in (`%%adb%% -s "%%serial_number%%" shell "settings get global ntp_server" 2^>^&1`) do (
        set ntp_server=%%X
    )

    if "%ntp_server%" NEQ "ntp1.aliyun.com" (
        set ntp_server=
        call :view_ntp_setup_failed
        exit /b 1
    )

    set ntp_server=
    call :view_ntp_server_has_set_as "ntp1.aliyun.com"
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_action_opt_empty
    color fc
    echo.
    echo [ش] ѡΪգ
exit /b 0
::
:view_run_adb_action_single_t
    set title_name=%title% %version% - ADB ˵ [%serial_number%]
exit /b 0
::
:view_do_remove_exclamation_t
    set title_name=%title% %version% - ȥͼϵ̾ /  [%serial_number%]
exit /b 0
::
:view_do_remove_frp_t
    set title_name=%title% %version% - Ƴ Google ָñ ^(FRP^) [%serial_number%]
exit /b 0
::
:view_do_setup_china_ntp_server_t
    set title_name=%title% %version% - ù NTP  [%serial_number%]
exit /b 0
::
:view_action_failed
    color fc
    echo.
    echo 豸 [%1] ʧܡ
exit /b 0
::
:view_frp_removed_tips
    echo.
    echo ĻFRP 
exit /b 0
::
:view_remove_exclamation_sucess
    echo.
    echo ȥ̾ / ȥɡ
exit /b 0
::
:view_ntp_setup_failed
    echo.
    echo  NTP ʧܣ
exit /b 0
::
:view_ntp_server_has_set_as
    echo.
    echo NTP Ϊ [%1]
exit /b 0
::
:view_frp_remove_rebooting
    echo.
    echo 豸...
exit /b 0
::
:view_action_done_footer
    echo.
    echo 豸 [%1] ɡ %2 
exit /b 0
::
:view_press_any_key_exit
    echo.
    echo 밴˳
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
:tips
    call :view_press_any_key_exit
    pause > nul
::
::
:exit
exit
