@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

@SETLOCAL enabledelayedexpansion

:run_erase_data_single
color f9
call :view_run_erase_data_single_t
@title %title_name%
    set /A failure_count=0
    set /A total_failure_count=0

    call "%~dp0get_partition_table.cmd"

    if "%FLAG_DEVICE_GPT_DAMAGED%" == "1" (
        call :view_device_gpt_damaged_tips
        exit /b 1
    )

    call :view_factory_reset_title

    call :run_oem_fb_mode_set

    call "%~dp0do_erase_data.cmd"
    set /A total_failure_count+=%failure_count%

    call :run_oem_fb_mode_clear

    if %total_failure_count% == 0 ( color f2 )

    call :view_erase_data_footer %serial_number% %total_failure_count%

    if "%DEVICE_COUNT%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:run_oem_fb_mode_set
    if "%FLAG_DEVICE_USE_MOT_OEM_FASTBOOT%" == "1" (
        call :view_fb_mode_set_tips
        !fastboot! -s !serial_number! oem fb_mode_set
    )
exit /b 0
::
::
:run_oem_fb_mode_clear
    if "%FLAG_DEVICE_USE_MOT_OEM_FASTBOOT%" == "1" (
        call :view_fb_mode_clear_tips
        !fastboot! -s !serial_number! oem fb_mode_clear
    )
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_run_erase_data_single_t
    set title_name=%title% %version% - ָ [%serial_number%]
exit /b 0
::
:view_fb_mode_set_tips
    echo.
    echo ==^>  FB ģʽ...
exit /b 0
::
:view_fb_mode_clear_tips
    echo.
    echo ==^>  FB ģʽ...
exit /b 0
::
:view_device_gpt_damaged_tips
    color fc
    echo.
    echo ش󣺵ǰ GPT 𻵣޷ȡλϢ
    echo ȳˢ GPT ֶлλ
exit /b 0
::
:view_factory_reset_title
    echo.
    echo ======== ڻָ ========
exit /b 0
::
:view_erase_data_footer
    echo.
    echo 豸 [%1] ѻָá %2 
exit /b 0
::
:view_press_any_key_exit
    echo.
    echo 밴˳
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
:tips
    call :view_press_any_key_exit
    pause > nul
::
::
:exit
exit
