@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

@SETLOCAL enabledelayedexpansion

:run_flash_all_single
color f9
call :view_run_flash_all_single_t
@title %title_name%
set /A failure_count=0
set /A total_failure_count=0

    call "%~dp0get_partition_table.cmd"

    call :run_oem_fb_mode_set

    if exist "%TFS_ROOT%tools\custom\custom.cmd" (
        call :view_run_custom_action
        call "%TFS_ROOT%tools\custom\custom.cmd"
        if !failure_count! NEQ 0 (
            set /A total_failure_count+=!failure_count!
            call :view_run_custom_failed !serial_number!
            REM exit /b 1
        )
    )

    call "%~dp0do_flash_all.cmd"
    set /A total_failure_count+=%failure_count%

    if exist "%TFS_ROOT%tools\custom\customend.cmd" (
        call :view_run_custom_end_action
        call "%TFS_ROOT%tools\custom\customend.cmd"
        if !failure_count! NEQ 0 (
            set /A total_failure_count+=!failure_count!
            call :view_run_custom_failed !serial_number!
            REM exit /b 1
        )
    )

    call :run_oem_fb_mode_clear

    if "%flashall_finished_reboot%" == "1" (
        REM mtk needs reboot-bootloader once
        if "!FLAG_DEVICE_IS_MTK!" == "1" (
            call :view_reboot_opt_title BOOTLOADER
            !fastboot! -s !serial_number! reboot-bootloader
            ping -n 3 127.1 > nul 2>nul
            call "%~dp0do_wait_fb_device.cmd" !serial_number!
            if !errorlevel! == 1 (
                set /A total_failure_count+=1
            )
        )

        call :view_reboot_opt_title SYSTEM
        !fastboot! -s !serial_number! reboot
        if !errorlevel! == 1 (
            set /A total_failure_count+=1
        )
    )

    if %total_failure_count% == 0 ( color f2 )

    call :view_flash_all_footer %serial_number% %total_failure_count%

    set serial_number=

    if "%DEVICE_COUNT%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:run_oem_fb_mode_set
    if "%FLAG_DEVICE_USE_MOT_OEM_FASTBOOT%" == "1" (
        call :view_fb_mode_set_tips
        !fastboot! -s !serial_number! oem fb_mode_set
    )
exit /b 0
::
::
:run_oem_fb_mode_clear
    if "%FLAG_DEVICE_USE_MOT_OEM_FASTBOOT%" == "1" (
        call :view_fb_mode_clear_tips
        !fastboot! -s !serial_number! oem fb_mode_clear
    )
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_run_flash_all_single_t
    set title_name=%title% %version% - ˢ̼ [%serial_number%]
exit /b 0
::
:view_fb_mode_set_tips
    echo.
    echo ==^>  FB ģʽ...
exit /b 0
::
:view_fb_mode_clear_tips
    echo.
    echo ==^>  FB ģʽ...
exit /b 0
::
:view_run_custom_action
    echo.
    echo ==^> ִԶű...
exit /b 0
::
:view_run_custom_end_action
    echo.
    echo ==^> ִԶűβ֣...
exit /b 0
::
:view_run_custom_failed
    echo.
    echo 豸 [%1] ִԶűʧܣ
exit /b 0
::
:view_run_custom_end_failed
    echo.
    echo 豸 [%1] ִԶűβ֣ʧܣ
exit /b 0
::
:view_reboot_opt_title
    echo.
    echo ------  %1 ------
exit /b 0
::
:view_flash_all_footer
    echo.
    echo 豸 [%1] ȫɡ %2 
exit /b 0
::
:view_press_any_key_exit
    echo.
    echo 밴˳
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
:tips
    call :view_press_any_key_exit
    pause > nul
::
::
:exit
exit
