@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

@SETLOCAL enabledelayedexpansion

:run_flash_recovery_single
color f9
call :view_run_flash_recovery_single_t
@title %title_name%

    if "%FLAG_FLASH_RECOVERY_OPT%" == "" (
        call :view_action_opt_empty
        goto :tips
    )
    if not exist "%FLAG_TARGET_FILE%" (
        call :view_img_not_exist
        goto :tips
    )
    set /A failure_count=0

    call "%~dp0get_partition_table.cmd"

    if "%FLAG_FLASH_RECOVERY_OPT%" == "1" call :do_direct_flash_recovery && goto :flash_recovery_end
    if "%FLAG_FLASH_RECOVERY_OPT%" == "2" call :do_boot_recovery_onetime && goto :flash_recovery_end

    :flash_recovery_end
    if %errorlevel% == 1 (
        set /A failure_count+=1
    )

    if %failure_count% == 0 ( color f2 )

    call :view_action_done_footer %serial_number% %failure_count%

    if "%DEVICE_COUNT%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:do_boot_recovery_onetime
call :view_do_boot_recovery_onetime_t
@title %title_name%
    set img_file=%FLAG_TARGET_FILE%
    set img_name=RECOVERY
    call :view_boot_recovery_title
    %fastboot% -s %serial_number% boot %img_file%
    if %errorlevel% == 1 (
        call :view_boot_image_failed !img_name!
        exit /b 1
    )
exit /b 0
::
::
:do_direct_flash_recovery
call :view_do_direct_flash_recovery_t
@title %title_name%
    if "%FLAG_DEVICE_HAS_RECOVERY%" == "1" (
        set img_file=!FLAG_TARGET_FILE!
        set img_name=RECOVERY
        set pt_name=recovery!SLOT_SUFFIX!
        call :view_flash_image_title !img_name!
        !fastboot! -s !serial_number! flash !pt_name! !img_file!
        if !errorlevel! == 1 (
            call :view_flash_image_failed !img_name!
            exit /b 1
        )
    ) else (
        call :view_partition_not_exist !img_name!
        exit /b 1
    )
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_run_flash_recovery_single_t
    set title_name=%title% %version% - ˢ RECOVERY [%serial_number%]
exit /b 0
::
:view_do_direct_flash_recovery_t
    set title_name=%title% %version% - ˢ RECOVERY [%serial_number%]
exit /b 0
::
:view_do_boot_recovery_onetime_t
    set title_name=%title% %version% - һ RECOVERY [%serial_number%]
exit /b 0
::
:view_action_opt_empty
    color fc
    echo.
    echo [ش] ѡΪգ
exit /b 0
::
:view_img_not_exist
    color fc
    echo.
    echo [ش] ļڣ
exit /b 0
::
:view_flash_image_title
    echo.
    echo ------ ˢ %1  ------
exit /b 0
::
:view_flash_image_failed
    color fc
    echo ------------------------------
    echo [] fastboot ˢ %1 ʧܣ
    echo ------------------------------
exit /b 0
::
:view_partition_not_exist
    color fc
    echo.
    echo [ش] 豸 %1 飡
exit /b 0
::
:view_boot_recovery_title
    echo.
    echo ------ һ RECOVERY  ------
exit /b 0
::
:view_boot_image_failed
    color fc
    echo ------------------------------
    echo [] fastboot  %1 ʧܣ
    echo ------------------------------
exit /b 0
::
:view_action_done_footer
    echo.
    echo 豸 [%1] ɡ %2 
exit /b 0
::
:view_press_any_key_exit
    echo.
    echo 밴˳
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
:tips
    call :view_press_any_key_exit
    pause > nul
::
::
:exit
exit
