@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

@SETLOCAL enabledelayedexpansion

:run_oem_unlock_single
color f9
call :view_run_oem_unlock_single_t
@title %title_name%

    if "%1" == "" (
        call :input_unlock_code
    ) else (
        set OEM_UNLOCK_CODE=%1
    )

    set /A failure_count=0

    call :do_oem_unlock_moto
    if !errorlevel! == 1 (
        set /A failure_count+=1
    )

    if %failure_count% == 0 ( color f2 )

    call :view_action_done_footer %serial_number% %failure_count%

    if "%DEVICE_COUNT%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:do_oem_unlock_moto
    if "%OEM_UNLOCK_CODE%" == "" (
        call :view_unlock_code_not_found
        exit /b 1
    )

    call :view_processing_cmd "fastboot -s %serial_number% oem unlock %OEM_UNLOCK_CODE%"
    %fastboot% -s %serial_number% oem unlock %OEM_UNLOCK_CODE%
    REM Confirm unlock again
    set /A okay_count=0

    for /F "usebackq tokens=*" %%X in (`%%fastboot%% -s %%serial_number%% oem unlock %%OEM_UNLOCK_CODE%% 2^>^&1`) do (
        echo %%X
        for /F "usebackq tokens=*" %%C in (`echo %%X 2^>^&1 ^| %%grep%% -i -c "unlocked"`) do (
            if "%%C" == "1" set /A okay_count+=1
        )
    )
    REM string "unlocked" occurrence count
    if %okay_count% == 0 (
        set okay_count=
        call :view_unlock_bl_failed !serial_number!
        exit /b 1
    )

    set okay_count=
    call :view_unlock_bl_sucess %serial_number%
exit /b 0
::
::
:input_unlock_code
    call :view_input_unlock_code_tips
    call :view_input_unlock_code
    set OEM_UNLOCK_CODE=
    set /p OEM_UNLOCK_CODE=
    if "%OEM_UNLOCK_CODE%"=="" (
        call :view_wrong_enter_wrong_tip
        ping 127.0.1 -n 2 >nul 2>nul
        goto :input_unlock_code
    )
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_run_oem_unlock_single_t
    set title_name=%title% %version% -  Motorola Bootloader [%serial_number%]
exit /b 0
::
:view_input_unlock_code_tips
    echo.
    echo. [-] ʾ Motorola վȡĽ룬س
    echo. [-] 磺DVNJ6NFFT2MLEZABQ4FQ
    echo.
exit /b 0
::
:view_input_unlock_code
    echo|set /p="벢س >>"
exit /b 0
::
:view_wrong_enter_wrong_tip
    echo 룡
exit /b 0
::
:view_processing_cmd
    echo.
    echo ==^> ִУ%1
exit /b 0
::
:view_unlock_bl_failed
    color fc
    echo.
    echo 豸 [%1]  Bootloader ʧܣ
exit /b 0
::
:view_unlock_bl_sucess
    echo.
    echo 豸 [%1] ɹBootloader ѽ
exit /b 0
::
:view_action_done_footer
    echo.
    echo 豸 [%1] ɡ %2 
exit /b 0
::
:view_press_any_key_exit
    echo.
    echo 밴˳
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
:tips
    call :view_press_any_key_exit
    pause > nul
::
::
:exit
exit
