@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

@SETLOCAL enabledelayedexpansion

:run_reboot_single
color f9
call :view_run_reboot_single_t
@title %title_name%
    set failure_count=0

    call :do_reboot_opt
    if %errorlevel% == 1 (
        set /A failure_count+=1
    )

    if %failure_count% == 0 ( color f2 )

    call :view_action_done_footer %serial_number% %failure_count%

    if "%DEVICE_COUNT%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:do_reboot_opt
    if "%FLAG_REBOOT_OPT%" == "system" (
        call :view_reboot_opt_title SYSTEM
        !fastboot! -s !serial_number! reboot
        if !errorlevel! == 1 (
            call :view_reboot_opt_failed !serial_number!
            exit /b 1
        )
        exit /b 0
    )

    if "%FLAG_REBOOT_OPT%" == "bootloader" (
        call :view_reboot_opt_title BOOTLOADER
        !fastboot! -s !serial_number! reboot-bootloader
        if !errorlevel! == 1 (
            call :view_reboot_opt_failed !serial_number!
            exit /b 1
        )
        exit /b 0
    )
    if "%FLAG_REBOOT_OPT%" == "fastboot" (
        call :view_reboot_opt_title FASTBOOTD
        !fastboot! -s !serial_number! reboot fastboot
        if !errorlevel! == 1 (
            call :view_reboot_opt_failed !serial_number!
            exit /b 1
        )
        exit /b 0
    )
    if "%FLAG_REBOOT_OPT%" == "recovery" (
        call :view_reboot_opt_title RECOVERY
        !fastboot! -s !serial_number! reboot recovery
        if !errorlevel! == 1 (
            call :view_reboot_opt_failed !serial_number!
            exit /b 1
        )
        exit /b 0
    )
    call :view_reboot_option_error && exit /b 1
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_run_reboot_single_t
    set title_name=%title% %version% - ѡ [%serial_number%]
exit /b 0
::
:view_reboot_opt_title
    echo.
    echo ------  %1 ------
exit /b 0
::
:view_reboot_opt_failed
    color fc
    echo.
    echo [] ʧܣ
exit /b 0
::
:view_reboot_option_error
    echo.
    echo [ش] ѡ
exit /b 0
::
:view_action_done_footer
    echo.
    echo 豸 [%1] ɡ %2 
exit /b 0
::
:view_press_any_key_exit
    echo.
    echo 밴˳
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
:tips
    call :view_press_any_key_exit
    pause > nul
::
::
:exit
exit
