@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:do_erase_data
REM setup variable failure_count
set /A failure_count=0

    if "%FLAG_DEVICE_HAS_CARRIER%" == "1" (
        set pt_name=carrier
        set pt_fname=CARRIER
        call :view_erase_partition_title !pt_fname!
        !fastboot! -s !serial_number! erase !pt_name!
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_erase_partition_failed !pt_fname!
        )
    )

    if "%FLAG_DEVICE_HAS_CACHE%" == "1" (
        set pt_name=cache
        set pt_fname=CACHE
        call :view_erase_partition_title !pt_fname!
        !fastboot! -s !serial_number! erase !pt_name!
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_erase_partition_failed !pt_fname!
        )
    )

    set pt_name=userdata
    set pt_fname=USERDATA
    call :view_erase_partition_title !pt_fname!
    %fastboot% -s %serial_number% erase !pt_name!
    if %errorlevel% == 1 (
        set /A failure_count+=1
        call :view_erase_partition_failed !pt_fname!
    )

    if "%FLAG_DEVICE_HAS_CUSTOMIZE%" == "1" (
        set pt_name=customize
        set pt_fname=CUSTOMIZE
        call :view_erase_partition_title !pt_fname!
        !fastboot! -s !serial_number! erase !pt_name!
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_erase_partition_failed !pt_fname!
        )
    )

    if "%FLAG_DEVICE_HAS_CLOGO%" == "1" (
        set pt_name=clogo
        set pt_fname=CLOGO
        call :view_erase_partition_title !pt_fname!
        !fastboot! -s !serial_number! erase !pt_name!
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_erase_partition_failed !pt_fname!
        )
    )

    REM only MTK or pre-installed android 10+ devices can erase metadata partition
    if "%FLAG_DEVICE_IS_MTK%" == "1" (
        goto :do_erase_metadata
    )
    if "%FLAG_DEVICE_HAS_SUPER%" == "1" (
        goto :do_erase_metadata
    )
    goto :do_erase_metadata_end

    :do_erase_metadata
    if "%FLAG_DEVICE_HAS_METADATA%" == "1" (
        set pt_name=metadata
        set pt_fname=METADATA
        call :view_erase_partition_title !pt_fname!
        !fastboot! -s !serial_number! erase !pt_name!
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_erase_partition_failed !pt_fname!
        )
    )
    :do_erase_metadata_end

    if "%FLAG_DEVICE_IS_QCOM%" == "1" (
        goto :do_erase_qcom_related
    )
    goto :do_erase_qcom_related_end

    :do_erase_qcom_related
    if "%FLAG_DEVICE_HAS_DDR%" == "1" (
        set pt_name=ddr
        set pt_fname=DDR
        call :view_erase_partition_title !pt_fname!
        !fastboot! -s !serial_number! erase !pt_name!
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_erase_partition_failed !pt_fname!
        )
    )

    if "%FLAG_DEVICE_HAS_OLDDDR%" == "1" (
        set pt_name=DDR
        set pt_fname=DDR
        call :view_erase_partition_title !pt_fname!
        !fastboot! -s !serial_number! erase !pt_name!
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_erase_partition_failed !pt_fname!
        )
    )
    :do_erase_qcom_related_end

exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_erase_partition_title
    echo.
    echo ------  %1  ------
exit /b 0
::
:view_erase_partition_failed
    color f6
    echo ---------------------------
    echo [] fastboot  %1 ʧܣ
    echo ---------------------------
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
