@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:do_erase_modem_cache
REM setup variable failure_count
    set /A failure_count=0
    if "%FLAG_DEVICE_IS_QCOM%" == "1" (
        set /A i=0
        if "!FLAG_DEVICE_HAS_MODEMST!" == "0" (
            set /A i+=1
        )
        if "!FLAG_DEVICE_HAS_MDM1M9KEFS!" == "0" (
            set /A i+=1
        )
        if !i! == 2 (
            set i=
            call :view_erase_modem_cache_not_exist
            exit /b 0
        )
        set i=
        call :do_erase_modem_cache_qcom
        exit /b 0
    )

    if "%FLAG_DEVICE_IS_MTK%" == "1" (
        if "!FLAG_DEVICE_HAS_NVDATA!" == "0" (
            call :view_erase_modem_cache_not_exist
            exit /b 0
        )
        call :do_erase_modem_cache_mtk
        exit /b 0
    )
    call :view_erase_modem_cache_not_exist

exit /b 0
::
::
:do_erase_modem_cache_qcom
    if "%FLAG_DEVICE_HAS_MODEMST%" == "1" (
        set pt_name=modemst1
        set pt_fname=MODEMST1
        call :view_erase_partition_title !pt_fname!
        !fastboot! -s !serial_number! erase !pt_name!
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_erase_partition_failed !pt_fname!
        )

        set pt_name=modemst2
        set pt_fname=MODEMST2
        call :view_erase_partition_title !pt_fname!
        !fastboot! -s !serial_number! erase !pt_name!
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_erase_partition_failed !pt_fname!
        )
    )

    if "%FLAG_DEVICE_HAS_MDM1M9KEFS%" == "1" (
        set pt_name=mdmddr
        set pt_fname=MDMDDR
        call :view_erase_partition_title !pt_fname!
        !fastboot! -s !serial_number! erase !pt_name!
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_erase_partition_failed !pt_fname!
        )

        set pt_name=mdm1m9kefs1
        set pt_fname=MDM1M9KEFS1
        call :view_erase_partition_title !pt_fname!
        !fastboot! -s !serial_number! erase !pt_name!
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_erase_partition_failed !pt_fname!
        )

        set pt_name=mdm1m9kefs2
        set pt_fname=MDM1M9KEFS2
        call :view_erase_partition_title !pt_fname!
        !fastboot! -s !serial_number! erase !pt_name!
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_erase_partition_failed !pt_fname!
        )
    )

exit /b 0
::
::
:do_erase_modem_cache_mtk
    if "%FLAG_DEVICE_HAS_NVDATA%" == "1" (
        set pt_name=nvdata
        set pt_fname=NVDATA
        call :view_erase_partition_title !pt_fname!
        !fastboot! -s !serial_number! erase !pt_name!
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_erase_partition_failed !pt_fname!
        )
    )
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_erase_modem_cache_not_exist
    echo.
    echo [ʾ] ڡ...
exit /b 0
::
:view_erase_partition_title
    echo.
    echo ------  %1  ------
exit /b 0
::
:view_erase_partition_failed
    color f6
    echo ---------------------------
    echo [] fastboot  %1 ʧܣ
    echo ---------------------------
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
