@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:do_flash_ap_generic
set /A failure_count=0

    if "%FLAG_DEVICE_HAS_SUPER%" == "1" (
        call :do_flash_ap_super
        if !errorlevel! == 1 (
            set /A failure_count+=1
        )
        goto :end_flash
    )
    if "%FLAG_DEVICE_AB_SLOT%" == "1" (
        call :do_flash_ap_old_system
        if !errorlevel! == 1 (
            set /A failure_count+=1
            goto :end_flash
        )
        call :do_flash_ap_old_system_b
        if !errorlevel! == 1 (
            set /A failure_count+=1
            goto :end_flash
        )
        call :do_flash_ap_old_product
        if !errorlevel! == 1 (
            set /A failure_count+=1
            goto :end_flash
        )
        call :do_flash_ap_old_vendor
        if !errorlevel! == 1 (
            set /A failure_count+=1
            goto :end_flash
        )
        call :do_flash_ap_old_oem
        if !errorlevel! == 1 (
            set /A failure_count+=1
            goto :end_flash
        )
        call :do_flash_ap_old_oem_b
        if !errorlevel! == 1 (
            set /A failure_count+=1
            goto :end_flash
        )
        goto :end_flash
    )

    if "%FLAG_DEVICE_AB_SLOT%" == "0" (
        call :do_flash_ap_old_system
        if !errorlevel! == 1 (
            set /A failure_count+=1
            goto :end_flash
        )
        call :do_flash_ap_old_product
        if !errorlevel! == 1 (
            set /A failure_count+=1
            goto :end_flash
        )
        call :do_flash_ap_old_vendor
        if !errorlevel! == 1 (
            set /A failure_count+=1
            goto :end_flash
        )
        call :do_flash_ap_old_oem
        if !errorlevel! == 1 (
            set /A failure_count+=1
            goto :end_flash
        )
        goto :end_flash
    )

    :end_flash
exit /b 0
::
::
:do_flash_ap_super
    REM return: 0 or 1
    if "%FLAG_DEVICE_HAS_SUPER%" NEQ "1" (
        goto :end_flash_super
    )

    set img_file=
    set img_name=SUPER
    set pt_name=super
    set file_format=0
    set /A A=0

    if exist super.img_sparsechunk.* (
        set img_file_prefix=super.img_sparsechunk.
        set file_format=0
        set /A A+=1
    )
    if exist super.img (
        set img_file=super.img
        set file_format=1
        set /A A+=1
    )
    if %A% GTR 1 (
        call :view_flash_image_duplicate_error1 !img_name!
        exit /b 1
    )
    if %A% == 0 (
        if "!skip_error_prompt!" NEQ "1" (
            call :view_flash_image_not_exist_e !img_name!
            exit /b 1
        )
    )

    REM if %A% == 1
    call :view_flash_image_title %img_name%

    if "%file_format%" == "0" (
        for /F "usebackq tokens=*" %%a in (`%%ls%% -1 !img_file_prefix!* ^|^ %%sort%% -n -k 3 -t . 2^>^&1`) do (
            call :view_flash_image_sparse %%a !img_name!
            !fastboot! -s !serial_number! flash !pt_name! %%a
            if !errorlevel! == 1 (
                call :view_flash_image_fatal_failed %%a
                exit /b 1
            )
        )
        goto :end_flash_super
    )

    if "%file_format%" == "1" (
        !fastboot! -s !serial_number! flash !pt_name! !img_file!
        if !errorlevel! == 1 (
            call :view_flash_image_fatal_failed !pt_name!
            exit /b 1
        )
    )
    :end_flash_super
exit /b 0
::
::
:do_flash_ap_old_system
    if "%FLAG_DEVICE_HAS_SYSTEM%" NEQ "1" (
        goto :end_flash_system
    )

    set img_file=
    set img_name=SYSTEM
    set pt_name=system%SLOT_SUFFIX%
    set file_format=0
    set /A A=0

    if exist system.img_sparsechunk* (
        set img_file_prefix=system.img_sparsechunk
        set file_format=0
        set /A A+=1
    )
    if exist system.img (
        set img_file=system.img
        set file_format=1
        set /A A+=1
    )
    if %A% GTR 1 (
        call :view_flash_image_duplicate_error1 !img_name!
        exit /b 1
    )
    if %A% == 0 (
        if "!skip_error_prompt!" NEQ "1" (
            call :view_flash_image_not_exist_e !img_name!
            exit /b 1
        )
    )

    REM if %A% == 1
    call :view_flash_image_title %img_name%

    if "%file_format%" == "0" (
        for /F "usebackq tokens=*" %%a in (`%%ls%% -1 !img_file_prefix!* ^|^ %%sort%% -n -k 3 -t . 2^>^&1`) do (
            call :view_flash_image_sparse %%a !img_name!
            !fastboot! -s !serial_number! flash !pt_name! %%a
            if !errorlevel! == 1 (
                call :view_flash_image_fatal_failed %%a
                exit /b 1
            )
        )
        goto :end_flash_system
    )

    if "%file_format%" == "1" (
        !fastboot! -s !serial_number! flash !pt_name! !img_file!
        if !errorlevel! == 1 (
            call :view_flash_image_fatal_failed !img_name!
            exit /b 1
        )
    )
    :end_flash_system
exit /b 0
::
::
:do_flash_ap_old_system_b
    if "%FLAG_DEVICE_HAS_SYSTEM%" NEQ "1" (
        goto :end_flash_system_b
    )
    if "%SLOT_SUFFIX%" == "_b" (
        goto :end_flash_system_b
    )
    if "%FLAG_DEVICE_AB_SLOT%" == "0" (
        goto :end_flash_system_b
    )

    set img_file=
    set img_name=SYSTEM_B
    set pt_name=system_b
    set file_format=0
    set /A A=0

    if exist system_b.img_sparsechunk* (
        set img_file_prefix=system_b.img_sparsechunk
        set file_format=0
        set /A A+=1
    )
    if exist system_other.img_sparsechunk* (
        set img_file_prefix=system_other.img_sparsechunk
        set file_format=0
        set /A A+=1
    )
    if exist system_b.img (
        set img_file=system_b.img
        set file_format=1
        set /A A+=1
    )
    if exist system_other.img (
        set img_file=system_other.img
        set file_format=1
        set /A A+=1
    )
    if %A% GTR 1 (
        call :view_flash_image_duplicate_error1 !img_name!
        exit /b 1
    )
    if %A% == 0 (
        if "!skip_error_prompt!" NEQ "1" (
            call :view_flash_image_not_exist !img_name!
            exit /b 0
        )
    )

    REM if %A% == 1
    call :view_flash_image_title %img_name%

    if "%file_format%" == "0" (
        for /F "usebackq tokens=*" %%a in (`%%ls%% -1 !img_file_prefix!* ^|^ %%sort%% -n -k 3 -t . 2^>^&1`) do (
            call :view_flash_image_sparse %%a !img_name!
            !fastboot! -s !serial_number! flash !pt_name! %%a
            if !errorlevel! == 1 (
                call :view_flash_image_fatal_failed %%a
                exit /b 1
            )
        )
        goto :end_flash_system_b
    )

    if "%file_format%" == "1" (
        !fastboot! -s !serial_number! flash !pt_name! !img_file!
        if !errorlevel! == 1 (
            call :view_flash_image_fatal_failed !img_name!
            exit /b 1
        )
    )
    :end_flash_system_b
exit /b 0
::
::
:do_flash_ap_old_product
    if "%FLAG_DEVICE_HAS_PRODUCT%" NEQ "1" (
        goto :end_flash_product
    )

    set img_file=
    set img_name=PRODUCT
    set pt_name=product%SLOT_SUFFIX%
    set file_format=0
    set /A A=0

    if exist product.img_sparsechunk* (
        set img_file_prefix=product.img_sparsechunk
        set file_format=0
        set /A A+=1
    )
    if exist product.img (
        set img_file=product.img
        set file_format=1
        set /A A+=1
    )
    if %A% GTR 1 (
        call :view_flash_image_duplicate_error1 !img_name!
        exit /b 1
    )
    if %A% == 0 (
        if "!skip_error_prompt!" NEQ "1" (
            call :view_flash_image_not_exist_e !img_name!
            exit /b 1
        )
    )

    REM if %A% == 1
    call :view_flash_image_title %img_name%

    if "%file_format%" == "0" (
        for /F "usebackq tokens=*" %%a in (`%%ls%% -1 !img_file_prefix!* ^|^ %%sort%% -n -k 3 -t . 2^>^&1`) do (
            call :view_flash_image_sparse %%a !img_name!
            !fastboot! -s !serial_number! flash !pt_name! %%a
            if !errorlevel! == 1 (
                call :view_flash_image_fatal_failed %%a
                exit /b 1
            )
        )
        goto :end_flash_product
    )

    if "%file_format%" == "1" (
        !fastboot! -s !serial_number! flash !pt_name! !img_file!
        if !errorlevel! == 1 (
            call :view_flash_image_fatal_failed !img_name!
            exit /b 1
        )
    )
    :end_flash_product
exit /b 0
::
::
:do_flash_ap_old_vendor
    if "%FLAG_DEVICE_HAS_PRODUCT%" NEQ "1" (
        goto :end_flash_vendor
    )

    set img_file=
    set img_name=VENDOR
    set pt_name=vendor%SLOT_SUFFIX%
    set file_format=0
    set /A A=0

    if exist vendor.img_sparsechunk* (
        set img_file_prefix=vendor.img_sparsechunk
        set file_format=0
        set /A A+=1
    )
    if exist vendor.img (
        set img_file=vendor.img
        set file_format=1
        set /A A+=1
    )
    if %A% GTR 1 (
        call :view_flash_image_duplicate_error1 !img_name!
        exit /b 1
    )
    if %A% == 0 (
        if "!skip_error_prompt!" NEQ "1" (
            call :view_flash_image_not_exist_e !img_name!
            exit /b 1
        )
    )

    REM if %A% == 1
    call :view_flash_image_title %img_name%

    if "%file_format%" == "0" (
        for /F "usebackq tokens=*" %%a in (`%%ls%% -1 !img_file_prefix!* ^|^ %%sort%% -n -k 3 -t . 2^>^&1`) do (
            call :view_flash_image_sparse %%a !img_name!
            !fastboot! -s !serial_number! flash !pt_name! %%a
            if !errorlevel! == 1 (
                call :view_flash_image_fatal_failed %%a
                exit /b 1
            )
        )
        goto :end_flash_vendor
    )

    if "%file_format%" == "1" (
        !fastboot! -s !serial_number! flash !pt_name! !img_file!
        if !errorlevel! == 1 (
            call :view_flash_image_fatal_failed !img_name!
            exit /b 1
        )
    )
    :end_flash_vendor
exit /b 0
::
::
:do_flash_ap_old_oem
    if "%FLAG_DEVICE_HAS_OEM%" NEQ "1" (
        goto :end_flash_oem
    )

    set img_file=
    set img_name=OEM
    set pt_name=oem%SLOT_SUFFIX%
    set file_format=0
    set /A A=0

    if exist oem.img_sparsechunk* (
        set img_file_prefix=oem.img_sparsechunk
        set file_format=0
        set /A A+=1
    )
    if exist oem.img (
        set img_file=oem.img
        set file_format=1
        set /A A+=1
    )
    if %A% GTR 1 (
        call :view_flash_image_duplicate_error1 !img_name!
        exit /b 1
    )
    if %A% == 0 (
        if "!skip_error_prompt!" NEQ "1" (
            call :view_flash_image_not_exist_e !img_name!
            exit /b 1
        )
    )

    REM if %A% == 1
    call :view_flash_image_title %img_name%

    if "%file_format%" == "0" (
        for /F "usebackq tokens=*" %%a in (`%%ls%% -1 !img_file_prefix!* ^|^ %%sort%% -n -k 3 -t . 2^>^&1`) do (
            call :view_flash_image_sparse %%a !img_name!
            !fastboot! -s !serial_number! flash !pt_name! %%a
            if !errorlevel! == 1 (
                call :view_flash_image_fatal_failed %%a
                exit /b 1
            )
        )
        goto :end_flash_oem
    )

    if "%file_format%" == "1" (
        !fastboot! -s !serial_number! flash !pt_name! !img_file!
        if !errorlevel! == 1 (
            call :view_flash_image_fatal_failed !img_name!
            exit /b 1
        )
    )
    :end_flash_oem
exit /b 0
::
::
:do_flash_ap_old_oem_b
    if "%FLAG_DEVICE_HAS_OEM%" NEQ "1" (
        goto :end_flash_oem_b
    )
    if "%SLOT_SUFFIX%" == "_b" (
        goto :end_flash_oem_b
    )
    if "%FLAG_DEVICE_AB_SLOT%" == "0" (
        goto :end_flash_oem_b
    )

    set img_file=
    set img_name=OEM_B
    set pt_name=oem_b
    set file_format=0
    set /A A=0

    if exist oem_b.img_sparsechunk* (
        set img_file_prefix=oem_b.img_sparsechunk
        set file_format=0
        set /A A+=1
    )
    if exist oem_b.img (
        set img_file=oem_b.img
        set file_format=1
        set /A A+=1
    )
    if exist oem_other.img (
        set img_file=oem_other.img
        set file_format=1
        set /A A+=1
    )
    if %A% GTR 1 (
        call :view_flash_image_duplicate_error1 !img_name!
        exit /b 1
    )
    if %A% == 0 (
        if "!skip_error_prompt!" NEQ "1" (
            call :view_flash_image_not_exist !img_name!
            exit /b 0
        )
    )

    REM if %A% == 1
    call :view_flash_image_title %img_name%

    if "%file_format%" == "0" (
        for /F "usebackq tokens=*" %%a in (`%%ls%% -1 !img_file_prefix!* ^|^ %%sort%% -n -k 3 -t . 2^>^&1`) do (
            call :view_flash_image_sparse %%a !img_name!
            !fastboot! -s !serial_number! flash !pt_name! %%a
            if !errorlevel! == 1 (
                call :view_flash_image_fatal_failed %%a
                exit /b 1
            )
        )
        goto :end_flash_oem_b
    )

    if "%file_format%" == "1" (
        !fastboot! -s !serial_number! flash !pt_name! !img_file!
        if !errorlevel! == 1 (
            call :view_flash_image_fatal_failed !img_name!
            exit /b 1
        )
    )
    :end_flash_oem_b
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_flash_image_duplicate_error1
    color fc
    echo.
    echo [ش] ͬʽ %1 ͬʱڡȻǲԵģ飡
exit /b 0
::
:view_flash_image_not_exist_e
    color fc
    echo.
    echo [ش] %1 񲻴ڡȻǲԵģ̼ļλã
exit /b 0
::
:view_flash_image_title
    echo.
    echo ------ ˢ %1  ------
exit /b 0
::
:view_flash_image_sparse
    echo.
    echo ==^> ˢ %2 ֶΣ%1
exit /b 0
::
:view_flash_image_fatal_failed
    color fc
    echo ------------------------------
    echo [ش] fastboot ˢ %1 ʧܣ
    echo ------------------------------
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
