@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:do_flash_bp_mtk
REM setup variable failure_count
set /A failure_count=0

    REM MODEM
    set img_file=
    set img_name=MODEM
    set pt_name=
    set /A A=0
    if exist radio.img set /A A+=1
    if exist NON-HLOS.bin set /A A+=1
    if exist modem.bin set /A A+=1
    if exist modem.img (
        set img_file=modem.img
        set img_name=MODEM
        set pt_name=modem!SLOT_SUFFIX!
        set /A A+=1
    )
    if exist md1img.img (
        set img_file=md1img.img
        set img_name=MD1IMG
        set pt_name=md1img!SLOT_SUFFIX!
        set /A A+=1
    )

    if %A% GTR 1 (
        call :view_flash_image_not_exist_e !img_name!
        exit /b 1
    )
    if %A% == 0 (
    if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
            set /A failure_count+=1
            call :view_flash_image_not_exist_e !img_name!
            exit /b 1
        )
    )
    if %A% == 1 (
        if "!img_file!" == "" (
            set /A failure_count+=1
            call :view_flash_image_format_error !img_name!
            exit /b 1
        )

        call :view_flash_image_title !img_name!
        !fastboot! -s !serial_number! flash !pt_name! !img_file!
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_flash_image_fatal_failed !img_name!
            exit /b 1
        )
    )

    if "%FLAG_DEVICE_HAS_MD1IMG2%" == "1" (
        set img_file=md1img2.img
        set img_name=MD1IMG2
        set pt_name=md1img2!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                color f6
                set /A failure_count+=1
                call :view_flash_image_fatal_failed !img_name!
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_flash_image_duplicate_error2
    color fc
    echo.
    echo [ش] ͵ %1 ͬʱڡȻǲԵģ飡
exit /b 0
::
:view_flash_image_not_exist_e
    color fc
    echo.
    echo [ش] %1 񲻴ڡȻǲԵģ̼ļλã
exit /b 0
::
:view_flash_image_format_error
    color fc
    echo.
    echo [ش] %1 ʽȷȻǲԵģ飡
exit /b 0
::
:view_flash_image_not_exist_w
    echo.
    echo [] %1 񲻴ڣ豸и÷ˢ...
exit /b 0
::
:view_flash_image_title
    echo.
    echo ------ ˢ %1  ------
exit /b 0
::
:view_flash_image_fatal_failed
    color fc
    echo ------------------------------
    echo [ش] fastboot ˢ %1 ʧܣ
    echo ------------------------------
exit /b 0
::
:view_flash_image_failed
    color f6
    echo ------------------------------
    echo [] fastboot ˢ %1 ʧܣ
    echo ------------------------------
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
