@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:do_flash_bp_qcom
REM setup variable failure_count
set /A failure_count=0

    REM MODEM
    set img_file=
    set img_name=MODEM
    set pt_name=
    set /A A=0
    if exist radio.img (
        set img_file=radio.img
        set img_name=RADIO
        set pt_name=radio
        set /A A+=1
    )
    if exist NON-HLOS.bin (
        set img_file=NON-HLOS.bin
        set img_name=MODEM
        set pt_name=modem!SLOT_SUFFIX!
        set /A A+=1
    )
    if exist modem.bin set /A A+=1
    if exist modem.img (
        set img_file=modem.img
        set img_name=MODEM
        set pt_name=modem!SLOT_SUFFIX!
        set /A A+=1
    )
    if exist md1img.img set /A A+=1

    if %A% GTR 1 (
        set /A failure_count+=1
        call :view_flash_image_duplicate_error2 !img_name!
        exit /b 1
    )
    if %A% == 0 (
        if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
            set /A failure_count+=1
            call :view_flash_image_not_exist_e !img_name!
            exit /b 1
        )
    )
    if %A% == 1 (
        if "!img_file!" == "" (
            set /A failure_count+=1
            call :view_flash_image_format_error !img_name!
            exit /b 1
        )

        call :view_flash_image_title !img_name!
        !fastboot! -s !serial_number! flash !pt_name! !img_file!
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_flash_image_fatal_failed !img_name!
            exit /b 1
        )
    )

    if "%FLAG_DEVICE_HAS_FSG%" == "1" (
        set img_file=fsg.mbn
        set img_name=FSG
        set pt_name=fsg!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
            )
        ) else (
            goto :need_check_radio_exist
        )
        goto :end_flash_fsg

        :need_check_radio_exist
        if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
            if not exist radio.img (
                call :view_flash_image_not_exist !img_name!
            )
        )
    )
    :end_flash_fsg

exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_flash_image_duplicate_error2
    color fc
    echo.
    echo [ش] ͵ %1 ͬʱڡȻǲԵģ飡
exit /b 0
::
:view_flash_image_not_exist_e
    color fc
    echo.
    echo [ش] %1 񲻴ڡȻǲԵģ̼ļλã
exit /b 0
::
:view_flash_image_format_error
    color fc
    echo.
    echo [ش] %1 ʽȷȻǲԵģ飡
exit /b 0
::
:view_flash_image_title
    echo.
    echo ------ ˢ %1  ------
exit /b 0
::
:view_flash_image_fatal_failed
    color fc
    echo ------------------------------
    echo [ش] fastboot ˢ %1 ʧܣ
    echo ------------------------------
exit /b 0
::
:view_flash_image_failed
    color f6
    echo ------------------------------
    echo [] fastboot ˢ %1 ʧܣ
    echo ------------------------------
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
