@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:do_flash_custom
REM setup variable failure_count
set /A failure_count=0

set /A _failure_count=0
set fully_customizable=0
set skip_fastbootd_actions=0
set finished_factory_reset=0

    if exist "%TFS_ROOT%tools\custom\custom.cmd" (
        call :view_run_custom_action
        call "%TFS_ROOT%tools\custom\custom.cmd"
        if !failure_count! NEQ 0 (
            set /A _failure_count+=!failure_count!
            REM set failure_count=!_failure_count!
            call :view_run_custom_failed !serial_number!
            REM exit /b 0
        )
    )

    if "%fully_customizable%" == "1" (
        goto :skip_do_flash_custom
    )

    REM "%fully_customizable%" != "0"
    call :do_flash_custom_apbp

    if "%FLAG_DEVICE_HAS_SUPER%" == "1" (
        if "!skip_fastbootd_action!" == "0" (
            call :do_fastbootd_actions
        )
    )

    :skip_do_flash_custom

    if "%finished_factory_reset%" == "1" (
        call :view_factory_reset_title
        call "%~dp0do_erase_data.cmd"
        set /A _failure_count+=!failure_count!
    )

    if exist "%TFS_ROOT%tools\custom\customend.cmd" (
        call :view_run_custom_end_action
        call "%TFS_ROOT%tools\custom\customend.cmd"
        if !failure_count! NEQ 0 (
            set /A _failure_count+=!failure_count!
            call :view_run_custom_end_failed !serial_number!
            goto :end_flash_custom
        )
    )

    :end_flash_custom
    set failure_count=%_failure_count%
    REM clear params
    set _failure_count=
    set fully_customizable=
    set skip_fastbootd_actions=
    set finished_factory_reset=
exit /b 0
::
::
:do_flash_custom_apbp
    if "%FLAG_DEVICE_IS_QCOM%" == "1" (
        call :view_flash_ap_title
        call "%~dp0do_flash_ap_qcom.cmd"
        if !errorlevel! == 1 (
            set /A _failure_count+=!failure_count!
            exit /b 1
        )
        set /A _failure_count+=!failure_count!
        call :view_flash_bp_title
        call "%~dp0do_flash_bp_qcom.cmd"
        if !errorlevel! == 1 (
            set /A _failure_count+=!failure_count!
            exit /b 1
        )
        set /A _failure_count+=!failure_count!
        goto :end_flash_device_spec
    )

    if "%FLAG_DEVICE_IS_MTK%" == "1" (
        call :view_flash_ap_title
        call "%~dp0do_flash_ap_mtk.cmd"
        if !errorlevel! == 1 (
            set /A _failure_count+=!failure_count!
            exit /b 1
        )
        set /A _failure_count+=!failure_count!
        call :view_flash_bp_title
        call "%~dp0do_flash_bp_mtk.cmd"
        if !errorlevel! == 1 (
            set /A _failure_count+=!failure_count!
            exit /b 1
        )
        set /A _failure_count+=!failure_count!
        goto :end_flash_device_spec
    )

    if "%FLAG_DEVICE_IS_SLSI%" == "1" (
        call :view_flash_ap_title
        call "%~dp0do_flash_ap_slsi.cmd"
        if !errorlevel! == 1 (
            set /A _failure_count+=!failure_count!
            exit /b 1
        )
        set /A _failure_count+=!failure_count!
        call :view_flash_bp_title
        call "%~dp0do_flash_bp_slsi.cmd"
        if !errorlevel! == 1 (
            set /A _failure_count+=!failure_count!
            exit /b 1
        )
        set /A _failure_count+=!failure_count!
        goto :end_flash_device_spec
    )
    :end_flash_device_spec

    call "%~dp0do_flash_ap_generic.cmd"
    set /A _failure_count+=%failure_count%
exit /b 0
::
::
:do_fastbootd_actions
    call :view_run_custom_boot_fastbootd
    call :view_reboot_opt_title FASTBOOTD
    %fastboot% -s %serial_number% reboot fastboot
    if %errorlevel% == 1 (
        set /A _failure_count+=1
        call :view_run_custom_boot_fastbootd_failed !serial_number!
        exit /b 1
    )
    ping -n 3 127.1 > nul 2>nul
    call "%~dp0do_wait_fb_device.cmd" %serial_number%

    call "%~dp0get_partition_table.md"
    if %errorlevel% == 1 (
        set /A _failure_count+=1
        call :view_device_get_partition_list_failed !serial_number!
        exit /b 1
    )

    call :do_flash_separated_super

    call :view_reboot_opt_title BOOTLOADER
    %fastboot% -s %serial_number% reboot bootloader
    ping -n 3 127.1 > nul 2>nul

    call "%~dp0do_wait_fb_device.cmd" %serial_number%
    if %errorlevel% == 1 (
        set /A _failure_count+=1
        exit /b 1
    )

exit /b 0
::
::
:do_flash_separated_super
    if "%FLAG_DEVICE_HAS_PRODUCT%" == "1" (
        set img_file=product.img
        set img_name=PRODUCT
        set pt_name=product!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A _failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_SYSTEM%" == "1" (
        set img_file=system.img
        set img_name=SYSTEM
        set pt_name=system!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A _failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_SYSTEM_EXT%" == "1" (
        set img_file=system_ext.img
        set img_name=SYSTEM_EXT
        set pt_name=system_ext!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A _failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_VENDOR%" == "1" (
        set img_file=vendor.img
        set img_name=VENDOR
        set pt_name=vendor!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A _failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_VENDOR_DLKM%" == "1" (
        set img_file=vendor.img
        set img_name=VENDOR_DLKM
        set pt_name=vendor!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A _failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_SYSTEM_DLKM%" == "1" (
        set img_file=system_dlkm.img
        set img_name=SYSTEM_DLKM
        set pt_name=system_dlkm!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A _failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_ODM%" == "1" (
        set img_file=odm.img
        set img_name=ODM
        set pt_name=odm!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A _failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_ODM_DLKM%" == "1" (
        set img_file=odm_dlkm.img
        set img_name=ODM_DLKM
        set pt_name=odm_dlkm!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A _failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_run_custom_action
    echo.
    echo ==^> ִԶű...
exit /b 0
::
:view_run_custom_end_action
    echo.
    echo ==^> ִԶűβ֣...
exit /b 0
::
:view_run_custom_failed
    echo.
    echo [] 豸 [%1] ִԶűʧܣ
exit /b 0
::
:view_run_custom_end_failed
    echo.
    echo [] 豸 [%1] ִԶűβ֣ʧܣ
exit /b 0
::
:view_flash_ap_title
    echo.
    echo ======== ˢ APϵͳ֣ ========
exit /b 0
::
:view_flash_bp_title
    echo.
    echo ======== ˢ BP֣  ========
exit /b 0
::
:view_factory_reset_title
    echo.
    echo ======== ڻָ ========
exit /b 0
::
:view_reboot_opt_title
    echo.
    echo ------  %1 ------
exit /b 0
::
:view_run_custom_boot_fastbootd
    echo.
    echo ==^> 豸Ϊ̬ fastbootd ģʽ...
exit /b 0
::
:view_run_custom_boot_fastbootd_failed
    color fc
    echo.
    echo [ش] 豸 [%1]  FastbootD ʧܣ
exit /b 0
::
:view_device_get_partition_list_failed
    color fc
    echo.
    echo [ش] 豸 [%1] ȡбʧܣ
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
