@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:do_wait_fb_device
    if "%1" == "" (
        color fc
        echo.
        echo do_wait_fb_device: Param serial_number missing.
        exit /b 1
    )

    call :view_reconnect_fb_device %1
    call :wait_fb_device %1 30
    if %errorlevel% == 1 (
        exit /b 1
    )
    call :wait_fb_device_ready %1 10
    if %errorlevel% == 1 (
        call :view_run_custom_reconnect_device_failed %1
        exit /b 1
    )
exit /b 0
::
::
:wait_fb_device_ready
    set _wait_time=%2
    set _device_timeout=0

    :wait_fb_device_ready_loop
        %fastboot% -s "%1" getvar serialno > nul 2>nul
        if %errorlevel% == 0 (
            exit /b 0
        )
        if "%_device_timeout%" == "%_wait_time%" (
            exit /b 1
        )
        set /A _device_timeout+=1
        ping -n 2 127.1 > nul 2>nul
    goto :wait_fb_device_ready_loop
exit /b 1
::
::
:wait_fb_device
    set _wait_time=%2
    set _device_list=
    set _device_timeout=0
    set _remain_time=0
    :wait_fb_device_loop
        for /F "usebackq tokens=1" %%X in (`%%fastboot%% devices`) do (
            if "%%X" NEQ "" (
                set _device_list=!_device_list! %%X
            )
        )
        set /A _device_timeout+=1
        set /A _remain_time=%_wait_time% - %_device_timeout%
        for %%a in (%_device_list%) do (
            if "%%a" == "%1" (
                call :view_device_connected %1
                set _wait_time=
                set _device_list=
                set _device_timeout=
                set _remain_time=
                exit /b 0
            )
        )
        if "%_device_timeout%" == "%_wait_time%" (
            call :view_device_connect_timeout
            set _wait_time=
            set _device_list=
            set _device_timeout=
            set _remain_time=
            exit /b 1
        )
        call :view_device_connect_waitingfor %_remain_time%
        ping -n 2 127.1 > nul 2>nul
    goto :wait_fb_device_loop
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_reconnect_fb_device
    echo.
    echo ------  [%1] ------
exit /b 0
::
:view_run_custom_reconnect_device_failed
    color fc
    echo.
    echo [ش]  [%1] ʧܣ
exit /b 0
::
:view_device_connected
    echo.
    echo [%1] ӡ
exit /b 0
::
:view_device_connect_timeout
    echo.
    echo ӳʱ豸ӡ
exit /b 0
::
:view_device_connect_waitingfor
    echo.
    echo ==^> ȴ豸ӡʣ [%1] 
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
