@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:do_xml2bat
    if "%1" == "" (
        color fc
        echo.
        echo do_xml2bat: Param is missing.
    )
    if "%2" == "" (
        color fc
        echo.
        echo do_xml2bat: Param is missing.
    )
    set xmlfile=%1
    set factoryreset=%2


    REM delete temp files
    del /f /s /q a.txt b.txt step.txt >nul 2>nul
    if %errorlevel% NEQ 0 (
        call :view_fatal_error_occurred
        exit /b 1
    )

    call :view_xml2bat_gen_headers

    echo @echo off> "%TFS_ROOT%xml2batflash.bat"
    echo @title Flashfile XML to BAT>> "%TFS_ROOT%xml2batflash.bat"
    echo color f9>> "%TFS_ROOT%xml2batflash.bat"
    echo set mfastboot=%fastboot%>> "%TFS_ROOT%xml2batflash.bat"
    echo echo ------------------------------------------------------------------------->> "%TFS_ROOT%xml2batflash.bat"
    echo echo Flashfile XML to BAT by @AlphaEva>> "%TFS_ROOT%xml2batflash.bat"
    echo echo ------------------------------------------------------------------------->> "%TFS_ROOT%xml2batflash.bat"
    echo echo.>> "%TFS_ROOT%xml2batflash.bat"
    echo echo Press any key to Continue...>> "%TFS_ROOT%xml2batflash.bat"
    echo pause ^> nul>> "%TFS_ROOT%xml2batflash.bat"

    call :view_xml2bat_gen_steps

    REM oem operation
    type %xmlfile% | %grep% -n "operation=\"oem\"" | %sed% "s@:.*operation=\"@ @g;s@\".*var=\"@ @g;s@\".*@@g" 2>&1 > step.txt

    REM flash operation

    REM Get partition name
    type %xmlfile% | %grep% -n "operation=\"flash\"" | %sed% "s@:.*partition=\"@ flash @g;s@\".*@@g" 2>&1 > a.txt

    REM Get filename
    type %xmlfile% | %grep% "operation=\"flash\"" | %sed% "s@.*filename=\"@@g;s@\".*@@g" 2>&1 > b.txt

    REM Merge
    %paste% -d" " a.txt b.txt 2>&1 >> step.txt

    REM erase operation
    if "%FLAG_KEEP_DATA%" == "0" (
        type !xmlfile! | !grep! -n "operation=\"erase\"" | !sed! "s@:.*operation=\"@ @g;s@\".*partition=\"@ @g;s@\".*@@g" 2>&1 >> step.txt
    )

    REM Merge to xml2batflash.bat
    type step.txt | %sort% -n | %awk% "{$1=null;print $0}" | %sed% "s/^[ \t]*//g;s@^@%%mfastboot%% @g" 2>&1 >> "%TFS_ROOT%xml2batflash.bat"

    call :view_xml2bat_gen_footers

    echo echo ------------------------------------------------------------------------->> "%TFS_ROOT%xml2batflash.bat"
    echo echo Please check if there are any errors first.>> "%TFS_ROOT%xml2batflash.bat"
    echo echo When you are finished checking, press the Enter key and the device will Reboot.>> "%TFS_ROOT%xml2batflash.bat"
    echo echo ------------------------------------------------------------------------->> "%TFS_ROOT%xml2batflash.bat"
    echo pause ^> nul>> "%TFS_ROOT%xml2batflash.bat"
    echo %%mfastboot%% reboot>> "%TFS_ROOT%xml2batflash.bat"
    echo exit>> "%TFS_ROOT%xml2batflash.bat"

    REM delete temp files
    del /f /s /q a.txt b.txt step.txt >nul 2>nul
    if %errorlevel% NEQ 0 (
        call :view_fatal_error_occurred
        exit /b 1
    )

    call :view_action_finished

exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_fatal_error_occurred
    color fc
    echo.
    echo [ش] ش
exit /b 0
::
:view_xml2bat_gen_headers
    echo.
    echo ==^> дļͷ...
exit /b 0
::
:view_xml2bat_gen_steps
    echo.
    echo ==^> д벽...
exit /b 0
::
:view_xml2bat_gen_footers
    echo.
    echo ==^> дĩβ...
exit /b 0
::
:view_action_finished
    echo.
    echo ɡ
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
