@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:menu_unlock_bl
call :view_menu_unlock_bl_t
@title %title_name%
color f9
    call :view_menu_unlock_bl
    call :view_press_key_num
    set selection=
    set /p selection=
    if "%selection%"=="1" cls && set "FLAG_UNLOCK_BL_OPT=!selection!" && call :sub_run_unlock_bl !selection!
    if "%selection%"=="2" cls && set "FLAG_UNLOCK_BL_OPT=!selection!" && call :sub_run_unlock_bl !selection!
    if "%selection%"=="3" cls && call :sub_run_unlock_bl_moto
    if "%selection%"=="4" cls && call :sub_run_get_device_id
    if "%selection%"=="0" cls && exit /b 0
    cls
goto :menu_unlock_bl
::
::
:sub_run_unlock_bl
call :view_sub_run_unlock_bl_t
@title %title_name%
color f9
    if "%1" == "1" (
        call :view_unlock_bl_generic_tips
        goto :end_show_unlock_tips
    )
    if "%1" == "2" (
        call :view_unlock_bl_generic_tips
        goto :end_show_unlock_tips
    )
    if "%1" == "3" (
        call :view_unlock_bl_mot_tips
        goto :end_show_unlock_tips
    )

    :end_show_unlock_tips
    call :view_press_key_continue

    call "%~dp0enumerate_fb_devices.cmd"

    if "%DEVICE_LIST%" NEQ "" (
        for %%d in (%DEVICE_LIST::= %) do (
            call :view_processing_device %%d
            set serial_number=%%d
            if "!DEVICE_COUNT!" == "1" (
                call "%~dp0run_flashing_unlock_single.cmd" %1
            ) else (
                start cmd /k call "%~dp0run_flashing_unlock_single.cmd" %1
            )
        )
    ) else (
        call :view_device_list_empty
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    call :view_press_any_key_return_menu_unlock_bl
    pause > nul
exit /b 0
::
::
:sub_run_unlock_bl_moto
call :view_sub_run_unlock_bl_moto_t
@title %title_name%
color f9
    call :view_unlock_bl_mot_tips
    call :view_press_key_continue

    call "%~dp0enumerate_fb_devices.cmd"

    if "!DEVICE_COUNT!" GTR "1" (
        call :input_read_code_from_file
        if "!FLAG_READ_CODE_FROM_FILE!" == "1" (
            goto :manual_input_code
        )

    )

    :manual_input_code
    if "%DEVICE_LIST%" NEQ "" (
        for %%d in (%DEVICE_LIST::= %) do (
            call :view_processing_device %%d
            set serial_number=%%d
            if "!DEVICE_COUNT!" == "1" (
                call "%~dp0run_oem_unlock_single.cmd"
            ) else (
                start cmd /k call "%~dp0run_oem_unlock_single.cmd"
            )
        )
    ) else (
        call :view_device_list_empty
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )
    goto :unlock_bl_end

    :read_code_from_file
    if "%DEVICE_LIST%" NEQ "" (
        for %%d in (%DEVICE_LIST::= %) do (
            call :view_processing_device %%d
            set serial_number=%%d
            if "!DEVICE_COUNT!" == "1" (
                call "%~dp0run_oem_unlock_unlockcode_single.cmd" unlockcode.txt
            ) else (
                start cmd /k call "%~dp0run_oem_unlock_unlockcode_single.cmd" unlockcode.txt
            )
        )
    ) else (
        call :view_device_list_empty
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    :unlock_bl_end
    call :view_press_any_key_return_menu_unlock_bl
    pause > nul
exit /b 0
::
::
:sub_run_get_device_id
call :view_sub_run_get_device_id_t
@title %title_name%
color f9

    call "%~dp0enumerate_fb_devices.cmd"

    if "%DEVICE_LIST%" NEQ "" (
        for %%d in (%DEVICE_LIST::= %) do (
            call :view_processing_device %%d
            set serial_number=%%d
            if "!DEVICE_COUNT!" == "1" (
                call "%~dp0run_get_device_id_single.cmd"
            ) else (
                start cmd /k call "%~dp0run_get_device_id_single.cmd"
            )
        )
    ) else (
        call :view_device_list_empty
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    if "%DEVICE_COUNT%" == "1" (
        goto :menu_get_device_id
    )

    call :view_press_any_key_return_menu_unlock_bl
    pause > nul
exit /b 0
::
::
:menu_get_device_id
    call :view_menu_get_device_id
    call :view_press_key_num
    set selection=
    set /p selection=
    if "%selection%"=="1" cls && start "" "https://motorola-global-portal.custhelp.com/app/standalone/bootloader/unlock-your-device-b" >nul 2>nul && goto :menu_get_device_id
    if "%selection%"=="2" cls && call :sub_run_get_device_id
    if "%selection%"=="3" cls && exit /b 0 && exit /b 0
    if "%selection%"=="0" cls && exit /b 0 && exit /b 0 && exit /b 0
    cls
    goto :menu_get_device_id
exit /b 0
::
::
:input_read_code_from_file
    set FLAG_READ_CODE_FROM_FILE=0
    call :view_input_read_code_from_file
    set selection=
    set /p selection=
    if "%selection%"=="y" && set "FLAG_READ_CODE_FROM_FILE=1" exit /b 0
    if "%selection%"=="n" && set "FLAG_READ_CODE_FROM_FILE=0" exit /b 0
    goto :input_read_code_from_file
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_menu_unlock_bl_t
    set title_name=%title% %version% -  Bootloader ˵
exit /b 0
::
:view_sub_run_unlock_bl_t
    set title_name=%title% %version% -  Bootloader ˵ BOOTLOADER
exit /b 0
::
:view_sub_run_unlock_bl_moto_t
    set title_name=%title% %version% -  Bootloader ˵ MOTOROLA BOOTLOADER
exit /b 0
::
:view_sub_run_get_device_id_t
    set title_name=%title% %version% -  Bootloader ˵ȡ豸 ID
exit /b 0
::
:view_menu_unlock_bl
    echo --------------------------------------------------------------------------------
    echo. [1] ͨ Android  豸 Bootloaderflashing unlock
    echo. [2] ͨ Android 豸 Bootloaderoem unlockɰ棩
    echo.
    echo. [3] ͨ Motorola 豸 Bootloaderoem unlockҪ룩
    echo. [4] ȡ Motorola 豸 IDget_unlock_data
    echo.
    echo. [0] ^<^<^< ˵
    echo --------------------------------------------------------------------------------
    echo.
    ::
exit /b 0
::
:view_press_key_num
    echo|set /p="ҪִеѡŲس>>"
exit /b 0
::
:view_input_read_code_from_file
    echo|set /p="Ƿ unlockcode.txt жȡ룿(Y/N) >>"
exit /b 0
::
:view_unlock_bl_generic_tips
    echo ================================================================================
    echo                                          ע
    echo ================================================================================
    echo. [*] òûݣװӦáý塢ô洢ϵļȵȡ
    echo. [*]  -^> ϵͳ -^> ѡУáOEM ѡſԽ
    echo. [*]  Bootloader ζʧȥ˹ٷޣÿοʱʾ档
    echo.
    echo. [*] 밴ѡUNLOCK THE BOOTLOADERѡȻԴȷȷ BL
    echo -------------------------------------------------------------------------------
    echo.
exit /b 0
::
:view_unlock_bl_mot_tips
    echo ================================================================================
    echo                                          ע
    echo ================================================================================
    echo. [*] òûݣװӦáý塢ô洢ϵļȵȡ
    echo. [*]  -^> ϵͳ -^> ѡУáOEM ѡſԽ
    echo. [*]  Bootloader ζʧȥ˹ٷޣÿοʱʾ档
    echo.
    echo. [*] 밴ѡUNLOCK THE BOOTLOADERѡȻԴȷȷ BL
    echo -------------------------------------------------------------------------------
    echo.
exit /b 0
::
:view_menu_get_device_id
        echo --------------------------------------------------------------------------------
        echo 裺
        echo. [*] 1.  Motorola ¼ Motorola  Google ˺ţ
        echo. [*] 2. 豸 ID ճύ򣬵㡰Can my device be unlockedť
        echo. [*] 3. Խ֡Request Unlock Keyťðť󣬽
        echo ŵ˻󶨵С
        echo.
        echo. [*] ע⣺ĳЩӪ̶Ƶ豸 Verizon޷ͨٷ Bootloader
        echo ʾYour device does not qualify for bootloader unlocking
        echo.
        echo. [1]  Motorola                 [2] »ȡ豸 ID
        echo. [3] ^<^< ؽ˵                       [0] ^<^<^< ˵
        echo --------------------------------------------------------------------------------
        echo.
exit /b 0
::
:view_press_key_continue
    echo 밴Ͻ  ˳
    pause > nul
exit /b 0
::
:view_processing_device
    echo.
    echo ڴ豸[%1]
exit /b 0
::
:view_device_list_empty
    color fc
    echo.
    echo [ش] Ҳ豸б
exit /b 0
::
:view_press_any_key_return_menu_unlock_bl
    echo.
    echo 밴ؽ Bootloader ˵
exit /b 0
::
:view_press_any_key_return_main_menu
    echo.
    echo 밴˵
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
:exit
exit
