@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

@SETLOCAL enabledelayedexpansion

:run_flash_diy_action_single
call :view_run_flash_diy_action_single_t
@title %title_name%
color f9
    if "%1" == "" (
        call :view_action_opt_empty
        goto :tips
    )

    set /A failure_count=0

    call :run_oem_fb_mode_set

    if "%1" == "1" (
        call :do_diy_erase
        if !errorlevel! == 1 (
            set /A failure_count+=1
        )
        goto :end_flash_diy_action
    )
    if "%1" == "2" (
        call :do_diy_flash
        if !errorlevel! == 1 (
            set /A failure_count+=1
        )
        goto :end_flash_diy_action
    )

    :end_flash_diy_action
    call :run_oem_fb_mode_clear

    if %failure_count% == 0 ( color f2 )

    call :view_action_done_footer %serial_number% %failure_count%

    if "%DEVICE_COUNT%" NEQ "1" (
        goto :tips
    )
exit /b 0
::
::
:do_diy_erase
call :view_do_diy_erase_t
@title %title_name%
    call :view_processing_cmd "fastboot erase %FLAG_TARGET_PARTITION_NAME%"
    REM Initialize the variable to 0.
    set /A _okay_count=0
    for /F "usebackq tokens=*" %%X in (`%%fastboot%% erase %%FLAG_TARGET_PARTITION_NAME%% 2^>^&1`) do (
        echo %%X
        for /F "usebackq tokens=*" %%C in (`echo %%X ^| %%grep%% -i -c "OKAY"`) do (
            if "%%C" == "1" set /A _okay_count+=1
        )
    )

    if %_okay_count% NEQ 1 (
        set _okay_count=
        call :view_erase_partition_failed !FLAG_TARGET_PARTITION_NAME!
        exit /b 1
    )
exit /b 0
::
::
:do_diy_flash
call :view_do_diy_flash_t
@title %title_name%
    call :view_processing_cmd "fastboot -s %serial_number% flash %FLAG_TARGET_PARTITION_NAME% %FLAG_TARGET_FILE%"

    REM Initialize the variable to 0.
    set /A _okay_count=0
    set /A _send_write_count=0

    for /F "usebackq tokens=*" %%X in (`%%fastboot%% -s %%serial_number%% flash %%FLAG_TARGET_PARTITION_NAME%% %%FLAG_TARGET_FILE%% 2^>^&1`) do (
        echo %%X
        for /F "usebackq tokens=*" %%C in (`echo %%X ^| %%grep%% -i -c "OKAY"`) do (
            if "%%C" == "1" set /A _okay_count+=1
        )
        for /F "usebackq tokens=*" %%C in (`echo %%X ^| %%grep%% -i -c "sending"`) do (
            if "%%C" == "1" set /A _send_write_count+=1
        )
        for /F "usebackq tokens=*" %%C in (`echo %%X ^| %%grep%% -i -c "writing"`) do (
            if "%%C" == "1" set /A _send_write_count+=1
        )
    )

    if %_okay_count% LSS 2 (
        goto :diy_flash_failed
    )
    if %_okay_count% NEQ %_send_write_count% (
        goto :diy_flash_failed
    )
    goto :diy_flash_failed_end

    :diy_flash_failed
        set _okay_count=
        set _send_write_count=
        call :view_flash_image_failed %FLAG_TARGET_PARTITION_NAME%
        exit /b 1
    :diy_flash_failed_end

    set _okay_count=
    set _send_write_count=
exit /b 0
::
::
:run_oem_fb_mode_set
    if "%FLAG_DEVICE_USE_MOT_OEM_FASTBOOT%" == "1" (
        call :view_fb_mode_set_tips
        !fastboot! -s !serial_number! oem fb_mode_set
    )
exit /b 0
::
::
:run_oem_fb_mode_clear
    if "%FLAG_DEVICE_USE_MOT_OEM_FASTBOOT%" == "1" (
        call :view_fb_mode_clear_tips
        !fastboot! -s !serial_number! oem fb_mode_clear
    )
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_action_opt_empty
    color fc
    echo.
    echo [ش] ѡΪգ
exit /b 0
::
:view_run_flash_diy_action_single_t
    set title_name=%title% %version% - DIY ˵ [%serial_number%]
exit /b 0
::
:view_do_diy_erase_t
    set title_name=%title% %version% -  %FLAG_TARGET_PARTITION_NAME%  [%serial_number%]
exit /b 0
::
:view_do_diy_flash_t
    set title_name=%title% %version% - ˢд %FLAG_TARGET_PARTITION_NAME%  [%serial_number%]
exit /b 0
::
:view_processing_cmd
    echo.
    echo ==^> ִУ%1
exit /b 0
::
:view_erase_partition_failed
    color fc
    echo ---------------------------
    echo []  %1 ʧܣ
    echo ---------------------------
exit /b 0
::
:view_flash_image_failed
    color fc
    echo ---------------------------
    echo [] fastboot ˢ %1 ʧܣ
    echo ---------------------------
exit /b 0
::
:view_fb_mode_set_tips
    echo.
    echo ==^>  FB ģʽ...
exit /b 0
::
:view_fb_mode_clear_tips
    echo.
    echo ==^>  FB ģʽ...
exit /b 0
::
:view_action_done_footer
    echo.
    echo 豸 [%1] ɡ %2 
exit /b 0
::
:view_press_any_key_exit
    echo.
    echo 밴˳
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
:tips
    call :view_press_any_key_exit
    pause > nul
::
::
:exit
exit
