@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

@SETLOCAL enabledelayedexpansion

:run_get_device_id_single
color f9
call :view_run_get_device_id_single_t
@title %title_name%
    set /A failure_count=0

    call :view_get_device_id_note %serial_number%
    call :do_get_device_id
    if %errorlevel% == 1 (
        set /A failure_count+=1
    )

    if %failure_count% == 0 ( color f2 )

    REM call :view_action_done_footer %serial_number% %failure_count%

    if "%DEVICE_COUNT%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:do_get_device_id
    set unlock_data=
    for /F "usebackq tokens=*" %%X in (`%%fastboot%% -s %%serial_number%% oem get_unlock_data 2^>^&1 ^| %%grep%% -viE "finished|waiting|Done|OKAY|Unlock|cid_data" ^| %%grep%% -v "\.\.\." ^| %%sed%% -e "s/(bootloader)//g;s/INFO//g" ^| %%tr%% -d "\r\n"`) do (
        set unlock_data=%%X
    )

    echo %unlock_data%

    if /i "%unlock_data%" == "Failed" (
        call :view_get_device_id_failed !serial_number!
        exit /b 1
    )

    if %DEVICE_COUNT% == 1 (
        REM do not try to format this line
        echo !unlock_data!| clip
        call :view_device_id_has_copied_to_clip
    )

    if %DEVICE_COUNT% NEQ 1 (
        call :view_device_id_is_written_to_file unlockdata_!serial_number!.txt
        echo !unlock_data! > unlockdata_!serial_number!.txt
        goto :tips
    )

exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_action_opt_empty
    color fc
    echo.
    echo [ش] ѡΪգ
exit /b 0
::
:view_run_get_device_id_single_t
    set title_name=%title% %version% - ȡ豸 ID [%serial_number%]
exit /b 0
::
:view_get_device_id_note
    echo.
    echo 豸 [%1] Ľݣ
    echo.
exit /b 0
::
:view_get_device_id_failed
    color fc
    echo.
    echo [] 豸 [%1] ȡ豸 ID ʧܣ
exit /b 0
::
:view_device_id_has_copied_to_clip
    echo.
    echo 豸 ID ѾƵ塣
exit /b 0
::
:view_device_id_is_written_to_file
    echo.
    echo ==^> дļ[%1]
exit /b 0
::
:view_action_done_footer
    echo.
    echo 豸 [%1] ɡ %2 
exit /b 0
::
:view_press_any_key_exit
    echo.
    echo 밴˳
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
:tips
    call :view_press_any_key_exit
    pause > nul
::
::
:exit
exit
