@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

@SETLOCAL enabledelayedexpansion

:run_get_deviceinfo_single
color f9
call :view_run_get_deviceinfo_single_t
@title %title_name%
    call :view_device_info_tips

    call :do_get_device_info

    if "%DEVICE_COUNT%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:do_get_device_info
    SETLOCAL
    set fastboot_getvar_all=
    for /F "usebackq tokens=*" %%X in (`%%fastboot%% -s %%serial_number%% getvar all 2^>^&1 ^| %%grep%% -viE "finished|waiting|Done|OKAY|Sending|failed" ^| %%grep%% -v "\.\.\." ^| %%sed%% -e "s/(bootloader)//g;s/INFO//g" ^| %%awk%% "{$1=$1; print}"`) do (
        set fastboot_getvar_all=!fastboot_getvar_all!###%%X
    )

    set info_device_sku=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% "/^sku: /{printf $2}"`) do (
        set info_device_sku=%%C
    )
    set info_device_product=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% "/^product: /{printf $2}"`) do (
        set info_device_product=%%C
    )
    set info_device_serialno=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% "/^serialno: /{printf $2}"`) do (
        set info_device_serialno=%%C
    )
    set info_device_cid=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% "/^cid: /{printf $2}"`) do (
        set info_device_cid=%%C
    )
    set info_device_date=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% "/^date: /{printf $2}"`) do (
        set info_device_date=%%C
    )
    set info_device_secure=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% "/^secure: /{printf $2}"`) do (
        set info_device_secure=%%C
    )
    set info_device_imei=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% "/^imei: /{printf $2}"`) do (
        set info_device_imei=%%C
    )
    set info_device_imei2=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% "/^imei2: /{printf $2}"`) do (
        set info_device_imei2=%%C
    )
    set info_device_esimid=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% "/^esimid: /{printf $2}"`) do (
        set info_device_esimid=%%C
    )
    set info_device_cpu=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% -F"cpu: " "{printf $2}"`) do (
        set info_device_cpu=%%C
    )
    set info_storage_type=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% "/^storage-type: /{printf $2}"`) do (
        set info_storage_type=%%C
    )
    set info_device_emmc=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% -F"emmc: " "{printf $2}"`) do (
        set info_device_emmc=%%C
    )
    set info_device_ufs=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% -F"ufs: " "{printf $2}"`) do (
        set info_device_ufs=%%C
    )
    set info_device_ram=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% -F"ram: " "{printf $2}"`) do (
        set info_device_ram=%%C
    )
    set info_device_radio=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% "/^radio: /{printf $2}"`) do (
        set info_device_radio=%%C
    )
    set info_device_channelid=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% "/^channelid: /{printf $2}"`) do (
        set info_device_channelid=%%C
    )
    set info_device_uid=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% "/^uid: /{printf $2}"`) do (
        set info_device_uid=%%C
    )
    set info_device_unlocked=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% "/^unlocked: /{printf $2}"`) do (
        set info_device_unlocked=%%C
    )
    set info_device_version_bootloader=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% "/^version-bootloader: /{printf $2}"`) do (
        set info_device_version_bootloader=%%C
    )
    set info_device_securestate=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% "/^securestate: /{printf $2}"`) do (
        set info_device_securestate=%%C
    )
    set info_device_iswarrantyvoid=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% "/^iswarrantyvoid: /{printf $2}"`) do (
        set info_device_iswarrantyvoid=%%C
    )
    set info_device_mot_sst=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% "/^mot_sst: /{printf $2}"`) do (
        set info_device_mot_sst=%%C
    )
    set info_device_ro_carrier=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% "/^ro.carrier: /{printf $2}"`) do (
        set info_device_ro_carrier=%%C
    )
    set info_device_slot_count=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% "/^slot-count: /{printf $2}"`) do (
        set info_device_slot_count=%%C
    )
    set info_device_latest_fingerprint=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%grep%% "ro.build.fingerprint" ^| %%awk%% -F"]: " "{printf $2}"`) do (
        set info_device_latest_fingerprint=%%C
    )
    set info_device_latest_baseband=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% -F"version-baseband: " "{printf $2}"`) do (
        set info_device_latest_baseband=%%C
    )
    set info_device_hwrev=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% "/^hwrev: /{printf $2}"`) do (
        set info_device_hwrev=%%C
    )
    set info_device_pcb_pn=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% "/^pcb-part-no: /{printf $2}"`) do (
        set info_device_pcb_pn=%%C
    )
    set info_device_primary_display=
    for /F "usebackq tokens=*" %%C in (`echo.%%fastboot_getvar_all%% ^| %%sed%% "s/###/\n/g" ^| %%awk%% "/^primary-display: /{printf $2}"`) do (
        set info_device_primary_display=%%C
    )
    set info_device_dualsim=
    for /F "usebackq tokens=*" %%C in (`%%fastboot%% -s %%serial_number%% oem hw dualsim 2^>^&1 ^| %%grep%% -viE "finished|waiting|Done|OKAY|Sending|failed" ^| %%grep%% -v "\.\.\." ^| %%sed%% -e "s/(bootloader)//g;s/INFO//g" ^| %%awk%% "{$1=$1; print}" ^| %%awk%% "/^dualsim: /{printf $2}"`) do (
        set info_device_dualsim=%%C
    )

    set info_device_svfuse=
    for /F "usebackq tokens=*" %%C in (`%%fastboot%% -s %%serial_number%% oem read_sv 2^>^&1 ^| %%grep%% -viE "finished|waiting|Done|OKAY|Sending|failed" ^| %%grep%% -v "\.\.\." ^| %%sed%% -e "s/(bootloader)//g;s/INFO//g" ^| %%awk%% "{$1=$1; print}"`) do (
        set info_device_svfuse=!info_device_svfuse!###%%C
    )

    REM ================================================================================
    call :view_device_info_status

    if "%info_device_sku%" == "" (
        set info_device_sku=!info_device_unknown!
    )
    if "%info_device_product%" == "" (
        set info_device_product=!info_device_unknown!
    )
    if "%info_device_hwrev%" == "" (
        set info_device_hwrev=!info_device_unknown!
    )
    if "%info_device_serialno%" == "" (
        set info_device_serialno=!info_device_unknown!
    )
    if "%info_device_cid%" == "" (
        set info_device_cid=!info_device_unknown!
    )
    if "%info_device_ro_carrier%" == "" (
        set info_device_ro_carrier=!info_device_unknown!
    )
    if "%info_device_radio%" == "" (
        set info_device_radio=!info_device_unknown!
    )
    if "%info_device_channelid%" == "" (
        set info_device_channelid=!info_device_unknown!
    )
    if "%info_device_date%" == "" (
        set info_device_date=!info_device_unknown!
    )
    if "%info_device_imei%" == "" (
        set info_device_imei=!info_device_unknown!
    )
    if "%info_device_uid%" == "" (
        set info_device_uid=!info_device_unknown!
    )
    if "%info_device_cpu%" == "" (
        set info_device_cpu=!info_device_unknown!
    )
    if "%info_device_ram%" == "" (
        set info_device_ram=!info_device_unknown!
    )
    if "%info_storage_type%" == "" (
        set info_storage_type=!info_device_unknown!
    )

    if /i "%info_storage_type%" == "EMMC" (
        set info_device_storage=!info_device_emmc!
    ) else if /i "%info_storage_type%" == "UFS" (
        set info_device_storage=!info_device_ufs!
    ) else (
        set info_device_storage=!info_device_unknown!
    )

    call :view_device_info_unlocked_status
    set info_device_unlocked_status=
    if "%info_device_unlocked%" NEQ "" (
        if /i "!info_device_unlocked!" == "yes" (
            set info_device_unlocked_status=!info_device_unlocked_yes!
        ) else if /i "!info_device_unlocked!" == "no" (
            set info_device_unlocked_status=!info_device_unlocked_no!
        )
    ) else (
        goto :case_info_device_securestate
    )
    goto :esac_info_device_securestate

    :case_info_device_securestate
        if /i "%info_device_securestate%" == "flashing_unlocked" (
            set info_device_unlocked_status=!info_device_unlocked_yes!
        ) else if /i "%info_device_securestate%" == "oem_locked" (
            set info_device_unlocked_status=!info_device_unlocked_no!
        ) else if /i "%info_device_securestate%" == "flashing_locked" (
            set info_device_unlocked_status=!info_device_unlocked_no1!
        ) else if /i "%info_device_securestate%" == "engineering" (
            set info_device_unlocked_status=!info_device_unlocked_yes1!
        ) else (
            set info_device_unlocked_status=!info_device_unknown!
        )
    :esac_info_device_securestate

    :if_info_device_securestate
        if "%info_device_securestate%" == "" (
            goto :case_info_device_mot_sst
        )
        goto :end_if_info_device_securestate

        :case_info_device_mot_sst
            if /i "%info_device_mot_sst%" == "0" (
                set info_device_securestate=locked
                goto :esac_info_device_mot_sst
            )
            if /i "%info_device_mot_sst%" == "1" (
                set info_device_securestate=factory_unlocked
                goto :esac_info_device_mot_sst
            )
            if /i "%info_device_mot_sst%" == "2" (
                set info_device_securestate=locked
                goto :esac_info_device_mot_sst
            )
            if /i "%info_device_mot_sst%" == "3" (
                set info_device_securestate=unlocked
                goto :esac_info_device_mot_sst
            )
            set info_device_securestate=%info_device_unknown%
        :esac_info_device_mot_sst
    :end_if_info_device_securestate

    set info_device_secure_status=
    if /i "%info_device_secure%" == "yes" (
        set info_device_secure_status=!info_device_no!
    ) else if /i "%info_device_secure%" == "no" (
        set info_device_secure_status=!info_device_yes!
    ) else (
        set info_device_secure_status=!info_device_unknown!
    )

    call :view_device_info_warranty_status
    set info_device_iswarrantyvoid_status=
    if /i "%info_device_iswarrantyvoid%" == "yes" (
        set info_device_iswarrantyvoid_status=!info_device_warranty_no!
    ) else if /i "%info_device_iswarrantyvoid%" == "no" (
        set info_device_iswarrantyvoid_status=!info_device_warranty_yes!
    ) else if /i "%info_device_iswarrantyvoid%" == "n/a" (
        set info_device_iswarrantyvoid_status=!info_device_warranty_yes!
    ) else (
        set info_device_iswarrantyvoid_status=!info_device_unknown!
    )

    set info_device_slot_ab_status=
    if /i "%info_device_slot_count%" == "1" (
        set info_device_slot_ab_status=!info_device_no!
    ) else if /i "%info_device_slot_count%" == "2" (
        set info_device_slot_ab_status=!info_device_yes!
    ) else if "%info_device_slot_count%" == "" (
        set info_device_slot_ab_status=!info_device_no!
    ) else (
        set info_device_slot_ab_status=!info_device_unknown!
    )

    if "%info_device_pcb_pn%" == "" (
        set info_device_pcb_pn=%info_device_unknown%
    )

    set info_device_dualsim_status=
    if "%info_device_dualsim%" == "true" (
        set info_device_dualsim_status=!info_device_yes!
    ) else if "%info_device_dualsim%" == "no" (
        set info_device_dualsim_status=!info_device_no!
    ) else (
        set info_device_dualsim_status=!info_device_unknown!
    )

    if "%info_device_latest_fingerprint%" == "" (
        set info_device_latest_fingerprint=!info_device_unknown!
    )

    if "%info_device_latest_baseband%" == "" (
        set info_device_latest_baseband=!info_device_unknown!
    )

    REM  view part
    call :view_device_info_bl_version "%info_device_version_bootloader%"
    call :view_device_info_sku "%info_device_sku%"
    call :view_device_info_product "%info_device_product%"
    call :view_device_info_hwrev "%info_device_hwrev%"
    call :view_device_info_serialno "%info_device_serialno%"
    call :view_device_info_cid "%info_device_cid%"
    call :view_device_info_carrier "%info_device_ro_carrier%"
    call :view_device_info_radio "%info_device_radio%"
    call :view_device_info_channelid "%info_device_channelid%"
    call :view_device_info_date "%info_device_date%"
    call :view_device_info_imei "%info_device_imei%"
    if "%info_device_imei2%" NEQ "" ( call :view_device_info_imei2 "!info_device_imei2!" )
    if "%info_device_esimid%" NEQ "" ( call :view_device_info_esimid "!info_device_esimid!" )
    call :view_device_info_uid "%info_device_uid%"
    call :view_device_info_cpu "%info_device_cpu%"
    call :view_device_info_ram "%info_device_ram%"
    call :view_device_info_storage_type "%info_storage_type%"
    call :view_device_info_storage "%info_device_storage%"
    if "%info_device_primary_display%" NEQ "" ( call :view_device_info_primary_display "!info_device_primary_display!" )
    call :view_device_info_secure "%info_device_secure_status%"
    call :view_device_info_securestate "%info_device_securestate%"
    call :view_device_info_unlocked "%info_device_unlocked_status%"
    call :view_device_info_iswarrantyvoid "%info_device_iswarrantyvoid_status%"
    call :view_device_info_slot_ab "%info_device_slot_ab_status%"
    call :view_device_info_fingerprint "%info_device_latest_fingerprint%"
    call :view_device_info_baseband "%info_device_latest_baseband%"
    call :view_device_info_pcb_pn "%info_device_pcb_pn%"
    call :view_device_info_dualsim "%info_device_dualsim_status%"

    echo --------------------------------------------------------------------------------
    call :view_device_info_svfuse_tips
    echo.%info_device_svfuse% | %sed% "s/###/\r\n/g"
    echo ================================================================================
    ENDLOCAL
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_run_get_deviceinfo_single_t
    set title_name=%title% %version% - ȡ豸Ϣ [%serial_number%]
exit /b 0
::
:view_device_info_tips
    cls
    echo.
    echo ================================================================================
    echo 豸һЩϢ
    echo ================================================================================
    echo Ϣ
exit /b 0
::
:view_device_info_status
    set info_device_unknown=δ֪
    set info_device_yes=
    set info_device_no=
exit /b 0
::
:view_device_info_unlocked_status
    set info_device_unlocked_yes=ѽ
    set info_device_unlocked_yes1=
    set info_device_unlocked_no=δ
    set info_device_unlocked_no1=ˢ
exit /b 0
::
:view_device_info_warranty_status
    set info_device_warranty_no=۶
    set info_device_warranty_yes=
exit /b 0
::
:view_device_info_bl_version
    echo BootLoader 汾ţ%~1
exit /b 0
::
:view_device_info_sku
    echo SKU ͺţ%~1
exit /b 0
::
:view_device_info_product
    echo Ʒţ%~1
exit /b 0
::
:view_device_info_hwrev
    echo Ӳ汾%~1
exit /b 0
::
:view_device_info_serialno
    echo кţ%~1
exit /b 0
::
:view_device_info_cid
    echo CID 룺%~1
exit /b 0
::
:view_device_info_carrier
    echo Ӫ̣%~1
exit /b 0
::
:view_device_info_radio
    echo Radio 룺%~1
exit /b 0
::
:view_device_info_channelid
    echo Channel 룺%~1
exit /b 0
::
:view_device_info_date
    echo ڣ%~1
exit /b 0
::
:view_device_info_imei
    echo IMEI%~1
exit /b 0
::
:view_device_info_imei2
    echo IMEI2%~1
exit /b 0
::
:view_device_info_esimid
    echo ESIMID%~1
exit /b 0
::
:view_device_info_uid
    echo UID%~1
exit /b 0
::
:view_device_info_cpu
    echo CPU ͺţ%~1
exit /b 0
::
:view_device_info_ram
    echo RAM ͺţ%~1
exit /b 0
::
:view_device_info_storage_type
    echo 洢оƬͣ%~1
exit /b 0
::
:view_device_info_storage
    echo 洢оƬͺţ%~1
exit /b 0
::
:view_device_info_primary_display
    echo Ļͺţ%~1
exit /b 0
::
:view_device_info_secure
    echo Ƿȫ繤̻%~1
exit /b 0
::
:view_device_info_securestate
    echo BL ȫ״̬%~1
exit /b 0
::
:view_device_info_unlocked
    echo BL ״̬%~1
exit /b 0
::
:view_device_info_iswarrantyvoid
    echo ˿%~1
exit /b 0
::
:view_device_info_slot_ab
    echo Ƿ֧ A/B λ%~1
exit /b 0
::
:view_device_info_fingerprint
    echo ϴγɹϵͳʱĹָ̼ƣ%~1
exit /b 0
::
:view_device_info_baseband
    echo ϴγɹϵͳʱĻ汾%~1
exit /b 0
::
:view_device_info_dualsim
    echo ǷΪ˫ SIM %~1
exit /b 0
::
:view_device_info_pcb_pn
    echo Ϻţ%~1
exit /b 0
::
:view_device_info_svfuse_tips
    echo ȫ˿汾 ( SV FUSE ) Ϣ
exit /b 0
::
:view_press_any_key_exit
    echo.
    echo 밴˳
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
:tips
    call :view_press_any_key_exit
    pause > nul
::
::
:exit
exit
