@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

@SETLOCAL enabledelayedexpansion

:run_oem_unlock_unlockcode_single
color f9
call :view_run_oem_unlock_unlockcode_single_t
@title %title_name%

    if "%1" == "" (
        call :view_param_invalid
        goto :tips
    )

    if "%2" == "" (
        call :view_param_invalid
        goto :tips
    )

    if not exist "%2" (
        call :view_param_invalid
        goto :tips
    )

    set /A failure_count=0

    call :read_unlock_code_from_file %serial_number% "%2"
    if %errorlevel% == 1 (
        set /A failure_count+=1
    ) else (
        call :do_oem_unlock_moto
        if !errorlevel! == 1 (
            set /A failure_count+=1
        )
    )

    if %failure_count% == 0 ( color f2 )

    call :view_action_done_footer %serial_number% %failure_count%

    if "%DEVICE_COUNT%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:do_oem_unlock_moto
    if "%OEM_UNLOCK_CODE%" == "" (
        call :view_unlock_code_not_found
        exit /b 1
    )

    call :view_processing_cmd "fastboot -s %serial_number% oem unlock %OEM_UNLOCK_CODE%"
    %fastboot% -s %serial_number% oem unlock %OEM_UNLOCK_CODE%
    REM Confirm unlock again
    set /A okay_count=0

    for /F "usebackq tokens=*" %%X in (`%%fastboot%% -s %%serial_number%% oem unlock %%OEM_UNLOCK_CODE%% 2^>^&1`) do (
        echo %%X
        for /F "usebackq tokens=*" %%C in (`echo %%X 2^>^&1 ^| %%grep%% -i -c "unlocked"`) do (
            if "%%C" == "1" set /A okay_count+=1
        )
    )
    REM string "unlocked" occurrence count
    if %okay_count% == 0 (
        set okay_count=
        call :view_unlock_bl_failed !serial_number!
        exit /b 1
    )

    set okay_count=
    call :view_unlock_bl_sucess %serial_number%
exit /b 0
::
::
:read_unlock_code_from_file
    if "%1" == "" (
        echo read_unlock_code_from_file: Param Serial Number is missing.
        goto :tips
    )
    if not exist "%2" (
        echo read_unlock_code_from_file: unlockcode.txt is missing.
        goto :tips
    )

    set OEM_UNLOCK_CODE=
    REM for /F "usebackq tokens=*" %%C in (`type %%X ^| %%awk%% -F"=" "{print $2}"`) do (
    REM     set OEM_UNLOCK_CODE=%%C
    REM )

    for /F "tokens=2 delims==" %%X in ('type "%2" ^| %grep% "%1"') do (
        set OEM_UNLOCK_CODE=%%X
    )

    if "%OEM_UNLOCK_CODE%" == "" (
        call :view_unlock_code_not_found
        exit /b 1
    )
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_run_oem_unlock_unlockcode_single_t
    set title_name=%title% %version% -  Motorola Bootloader [%serial_number%]
exit /b 0
::
:view_param_invalid
    color fc
    echo.
    echo [ش] 飡
exit /b 0
::
:view_unlock_code_not_found
    color fc
    echo.
    echo [ش] δļҵ [%1] Ľ룡
exit /b 0
::
:view_processing_cmd
    echo.
    echo ==^> ִУ%1
exit /b 0
::
:view_unlock_bl_failed
    color fc
    echo.
    echo 豸 [%1]  Bootloader ʧܣ
exit /b 0
::
:view_unlock_bl_sucess
    echo.
    echo 豸 [%1] ɹBootloader ѽ
exit /b 0
::
:view_action_done_footer
    echo.
    echo 豸 [%1] ɡ %2 
exit /b 0
::
:view_press_any_key_exit
    echo.
    echo 밴˳
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
:tips
    call :view_press_any_key_exit
    pause > nul
::
::
:exit
exit
